C**********************************************************************
      SUBROUTINE POTGR(XCALL,PIM,P,NCHAN,JSPIN,LINT,NLOC,NS)          
C**********************************************************************
C     GREEN TRANSFORMATION FOR POTENTIALS ON SU(2)-BASIS
C     FOR AKS(I)=0
C----------------------------------------------------------------------

      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGERST,IGRTST
      COMMON/POT/VCLL,VSIGLL,VTENLL,VSOLL,VSO2LL,FILL,DFILL,DDFILL,
     .           VCSS,VSIGSS,VTENSS,VSOSS,VSO2SS,FISS,DFISS,DDFISS,
     .           VCLS,VSIGLS,VTENLS,VSOLS,VSO2LS,FILS,DFILS,DDFILS,
     .           VCDR,VSIGDR,VTENDR,VSODR,VSO2DR,FIDR,DFIDR,DDFIDR,
     .           FISLL,DFISLL,DDFSLL,FISSS,DFISSS,DDFSSS,
     .           FISLS,DFISLS,DDFSLS,FISDR,DFISDR,DDFSDR,
     .           VASOLL,VASOSS,VASOLS,VASODR
**   .          ,VCNN,VSIGNN,VTENNN,VSONN,VSO2NN
      COMMON/STPS/H,NMAX,NSTPD,KSTPD(5),NMIN
      DIMENSION XA(300),TGRA(3,3,300),TGRPA(3,3,300)
      DIMENSION PHI(3,3),DPHI(3,3),TGR(3,3),TGRP(3,3),
     .          AB(3,3),PHIO(3,3),DPHIO(3,3),TGINT(3,3,3),TGPINT(3,3,3)
      DATA ICALL/0/,PHI/9*0.D0/,DPHI/9*0.D0/,AB/9*0.D0/
      SAVE XA,TGRA,TGRAP
C----------------------------------------------------------------------

C     GENERATION GREEN TRANSFORMATIONS FOR THE POINT XA(I):
      IF(ICALL.EQ.0) THEN

      CALL XVALS(XA)       

C     FOR SUBROUTINE GREEN : REVERSAL LOOP VARIABLE :
C
      DO 4 II=2,NMAX
C
      I=NMAX+2-II
      X=XA(I)
      CALL VMATP(X,PIM,P,NCHAN,JSPIN,LINT,NLOC,NS)          
C
C     GREEN TRANSFORMATION MATRICES : TGR,TGRP,GRPP :
C
*     IF(XA(I).GE.0.35D0) THEN
      PHI(1,1)=1.D0+2*FILL
      PHI(1,2)=2*FILS
      PHI(2,2)=1.D0+2*FISS
      PHI(2,1)=PHI(1,2)
      PHI(3,3)=1.D0+2*FIDR
      DPHI(1,1)=2*DFILL/PIM
      DPHI(1,2)=2*DFILS/PIM
      DPHI(2,2)=2*DFISS/PIM
      DPHI(2,1)=DPHI(1,2)
      DPHI(3,3)=2*DFIDR/PIM
C
C     INPUT : PHI-,DPHI-MATRIX ON THE ISOSPIN BASIS
C
      IF(X.LT.0.7D0) CALL GRNTST(X,PHI,DPHI,IRET)
      CALL GREEN (1,II,X,PHI,DPHI,TGR,TGRP,PHIO,DPHIO)
C
C     OUTPUT: TGR,TGRP:  ON SU(2)-BASIS
C
      DO 14 KK=1,3
      DO 14 LL=1,3
      TGRA(KK,LL,I) = TGR(KK,LL)
   14 TGRPA(KK,LL,I) = TGRP(KK,LL)

    4 CONTINUE
      ENDIF
C----------------------------------------------------------------------
C
C     GREEN'S TRANSFORMATION
C
      IVAL = NMAX
      IIMIN=1
      IIMAX=NMAX
      DO 10 I=1,NMAX
   10 IF(XCALL.GE.XA(I).AND.XCALL.LE.XA(I+1)) IVAL=I
C
C     GENERATION GREEN TRANSFORMATION MATRICES BY INTERPOLATION:
C
      NMAX1 = NMAX-1
      IF(IVAL.LT.NMAX1) THEN
      DO 11 KK=1,3
      DO 11 LL=1,3
      DO 11 II=1,3
      TGINT(KK,LL,II)=TGRA(KK,LL,IVAL+II-1)
      TGPINT(KK,LL,II)=TGRPA(KK,LL,IVAL+II-1)
   11 CONTINUE
      CALL INTPOL3(XCALL,IVAL,NMAX,XA,TGINT,TGR)
      CALL INTPOL3(XCALL,IVAL,NMAX,XA,TGPINT,TGRP)
      ENDIF
      IF(IVAL.EQ.NMAX) THEN
      DO 12 KK=1,3
      DO 12 LL=1,3
      TGR(KK,LL) = 0.D0
      TGRP(KK,LL) = 0.D0
   12 IF(KK.EQ.LL) TGR(KK,LL)=1.D0
      ENDIF
*     write(*,*) 'at 3, grnpack: ival=',ival,' xcall=',xcall
*     write(*,*) 'grnpack: tgr=',tgr       
*     write(*,*) 'grnpack: tgrp=',tgrp       

      CALL VMATP(XCALL,PIM,P,NCHAN,JSPIN,LINT,NLOC,NS)          
      PHI(1,1)=1.D0+2*FILL
      PHI(1,2)=2*FILS
      PHI(2,2)=1.D0+2*FISS
      PHI(2,1)=PHI(1,2)
      PHI(3,3)=1.D0+2*FIDR
      DPHI(1,1)=2*DFILL/PIM
      DPHI(1,2)=2*DFILS/PIM
      DPHI(2,2)=2*DFISS/PIM
      DPHI(2,1)=DPHI(1,2)
      DPHI(3,3)=2*DFIDR/PIM
C
C     GREEN TRANSFORMATION CENTRAL POTENTIAL:
      AB(1,1  )= VCLL
      AB(1,2  )= VCLS                           
      AB(2,2  )= VCSS                                           
      AB(3,3  )= VCDR                                           
      AB(2,1  )= AB(1,2  )
      CALL GRNTRN(X,AB,PHI,DPHI,TGR,TGRP)
      VCLL = AB(1,1  )
      VCLS = AB(1,2  )                           
      VCSS = AB(2,2  )                                           
      VCDR = AB(3,3  )                                           
C     GREEN TRANSFORMATION SPIN-SPIN POTENTIAL:
      AB(1,1  )= VSIGLL
      AB(1,2  )= VSIGLS                           
      AB(2,2  )= VSIGSS                                           
      AB(3,3  )= VSIGDR                                           
      AB(2,1  )= AB(1,2  )
      CALL GRNTRN(X,AB,PHI,DPHI,TGR,TGRP)
      VSIGLL = AB(1,1  )
      VSIGLS = AB(1,2  )                           
      VSIGSS = AB(2,2  )                                           
      VSIGDR = AB(3,3  )                                           
C     GREEN TRANSFORMATION TENSOR POTENTIAL:
      AB(1,1  )= VTENLL
      AB(1,2  )= VTENLS                           
      AB(2,2  )= VTENSS                                           
      AB(3,3  )= VTENDR                                           
      AB(2,1  )= AB(1,2  )
      CALL GRNTRN(X,AB,PHI,DPHI,TGR,TGRP)
      VTENLL = AB(1,1  )
      VTENLS = AB(1,2  )                           
      VTENSS = AB(2,2  )                                           
      VTENDR = AB(3,3  )                                           
C     GREEN TRANSFORMATION SPIN-ORBIT POTENTIAL:
      AB(1,1  )= VSOLL
      AB(1,2  )= VSOLS                           
      AB(2,2  )= VSOSS                                           
      AB(3,3  )= VSODR                                           
      AB(2,1  )= AB(1,2  )
      CALL GRNTRN(X,AB,PHI,DPHI,TGR,TGRP)
      VSOLL = AB(1,1  )
      VSOLS = AB(1,2  )                           
      VSOSS = AB(2,2  )                                           
      VSODR = AB(3,3  )                                           
C     GREEN TRANSFORMATION QUADRATIC SPIN-ORBIT POTENTIAL:
      AB(1,1  )= VSO2LL
      AB(1,2  )= VSO2LS                           
      AB(2,2  )= VSO2SS                                           
      AB(3,3  )= VSO2DR                                           
      AB(2,1  )= AB(1,2  )
      CALL GRNTRN(X,AB,PHI,DPHI,TGR,TGRP)
      VSO2LL = AB(1,1  )
      VSO2LS = AB(1,2  )                           
      VSO2SS = AB(2,2  )                                           
      VSO2DR = AB(3,3  )                                           
C     GREEN TRANSFORMATION ANTI-SYMMETRIC SPIN-ORBIT POTENTIAL:
      AB(1,1  )= VSOALL
      AB(1,2  )= VSOALS                           
      AB(2,2  )= VSOASS                                           
      AB(3,3  )= VSOADR                                           
      AB(2,1  )= AB(1,2  )
      CALL GRNTRN(X,AB,PHI,DPHI,TGR,TGRP)
      VASOLL = AB(1,1  )
      VASOLS = AB(1,2  )                           
      VASOSS = AB(2,2  )                                           
      VASODR = AB(3,3  )                                           
C
      ICALL = 1
      RETURN
      END
c *******************************************************************
      subroutine xvals(xa)
c *******************************************************************
      implicit real*8(a-h,o-z)
      dimension xa(300)
      common /stps/h,nmax,nstpd,kstpd(5),nmin
      dimension kstps(5)
c     data hi/0.5d-02/,nmaxi/300/,nstps/4/,kstps/50,150,250,300,0/
      data hi/0.3d-01/,nmaxi/100/,nstps/2/,kstps/20,40,100,0,0/    
      data x0/0.d0/

      h=hi  
      nmax=nmaxi
      nstpd=nstps
      do 10 ii=1,5
   10 kstpd(ii)=kstps(ii)
      xa(1) = x0
      do 7 i=2,nmax
      hh=h
      do 71 ii=1,nstpd
   71 if(i.gt.kstpd(ii)) hh=2*hh
    7 xa(i) = xa(i-1)+hh
*     write(*,*) 'xvals: xa=',xa
      return
      end
C *******************************************************************
      SUBROUTINE GRNTRN(XA,AB,PHI,PHIP,TGR,TGRP)
C *******************************************************************
*
*     CALLED BY POTGR FOR CONSTRUCTION POT'S -MATRIX AFTER GREEN-TRANSF.
*
*     NOTE THAT HERE : PHI = M-MATRIX=1 + 2 * PHI ETC.
C *******************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION AB(3,3),TGR(3,3),TGRP(3,3),
     ,          PHI(3,3),PHIP(3,3),AI(3,3),
     ,          PHITGR(3,3),PHITGM(3,3),PHPTGP(3,3),ABTGR(3,3)
      DATA AI/1.D0,0.D0,0.D0,0.D0,1.D0,0.D0,0.D0,0.D0,1.D0/
      N=3
      NN=N/3
C     PRINT 51
C     DO 50 KK=1,N
C 50  PRINT 61, (AB(KK,LL),LL=1,N)
C 51  FORMAT('  ENTERING GRNTRN : ')
C     DO 2000 I=1,3
C2000 PRINT 2001, (PHI(I,J),J=1,3),(PHIP(I,J),J=1,3)
C2001 FORMAT(/,'  GRNTRN PHI=',3(D12.5,2X),'  PHIP=',3(D12.5,2X))
C     DO 3000 I=1,3
C3000 PRINT 3001, (TGR(I,J),J=1,3),(TGRP(I,J),J=1,3)
C3001 FORMAT(/,'  GRNTRN TGR=',3(D12.5,2X),'  TGRP=',3(D12.5,2X))
C4000 CONTINUE
C
      DO 1 I=1,3
      DO 1 IA=1,NN
      IIA=NN*(I-1)+IA
      DO 2 J=1,3
      DO 2 JB=1,NN
      JJB=NN*(J-1)+JB
      PHITGR(IIA,JJB)=0.D0
      PHPTGP(IIA,JJB)=0.D0
      DO 11 K=1,3
      PHITGR(IIA,JJB)=PHITGR(IIA,JJB)+PHI(I,K)*TGR(K,J)*AI(IA,JB)
   11 PHPTGP(IIA,JJB)=PHPTGP(IIA,JJB)+PHIP(I,K)*TGRP(K,J)*AI(IA,JB)
    2 CONTINUE
    1 CONTINUE
C
      DO 3 I=1,3
      DO 3 IA=1,NN
      IIA=NN*(I-1)+IA
      DO 4 J=1,3
      DO 4 JB=1,NN
      JJB=NN*(J-1)+JB
      ABTGR (IIA,JJB)=0.D0
      DO 41 K=1,3
      DO 41 KC=1,NN
      KKC=NN*(K-1)+KC
   41 ABTGR(IIA,JJB)=ABTGR(IIA,JJB)+AB(IIA,KKC)*TGR(K,J)*AI(KC,JB)
    4 CONTINUE
    3 CONTINUE
C
      DO 5 I=1,3
      DO 5 J=1,3
      PHITGM(I,J)=0.D0
    5 PHITGM(I,I)=1.D0
      CALL INVER3(PHITGM,PHITGR)
C
      DO 6 I=1,N
      DO 6 J=1,N
      AB(I,J)=0.D0
      DO 7 K=1,N
    7 AB(I,J)=AB(I,J) +
     +            0.5D0*PHITGM(I,K) * PHPTGP(K,J)
    6 CONTINUE
      DO 8 I=1,N
      DO 8 J=1,N
      DO 9 K=1,N
    9 AB(I,J)=AB(I,J)+
     +             PHITGM(I,K) * ABTGR(K,J)
    8 CONTINUE
C     PRINT 62
C     DO 60 KK=1,N
C 60  PRINT 61, (AB(KK,LL),LL=1,N)
C 61  FORMAT(' GRNTRN AB=',6(D12.5,5X))
C 62  FORMAT('  LEAVING GRNTRN : ')
      RETURN
      END
C **************************************************************
      SUBROUTINE GREEN (ICH,INDX,X,BM,BMP,T,TP,BMO,BMPO)
*     CALLED BY :
*     AMATLP/AMATLN FOR CONSTRUCTION OF GREEN-TRANSFORMATION
C **************************************************************
C
*     THIS VERSION (2) SOLVES THE DIFFERENTIAL EQUATION :
*
*                  2 * BM * TP + BMP * T= 0
*
*     STARTING FROM X=XMAX AND GOING INSIDE TOWARDS X=0
*
*     FIRST CALLS SHOULD HAVE INDX=2       ,3         ,4         , ...
*     CORRESPONDING TO           X=XA(NMAX),XA(NMAX-1),XA(NMAX-2), ...
*
*     IN CALLING PROGRAM X=XA(IX), IX=NMAX+2-INDX, INDX=2,NMAX
*
*     ICH=1 : LAMBDA-PROTON  SYSTEM
*     ICH=2 : LAMBDA-NEUTRON SYSTEM
*
C
C     T   : GREEN-TRANSFORMATION MATRIX ON THE PARTICLE BASIS
C     TI  :   ,,       ,,          ,,   ,,  ,, ISOSPIN   ,,
C
C     INPUT  : BM   = COEFFICIENT MATRIX OF U'' (ISOSPIN=1/2)
C              BMP  =     ,,        ,,   OF U'  (     ,,    )
C              BM(3,3) = COEFFICIENT MATRIX OF U'' (ISOSPIN=3/2)
C              BMP(3,3)=     ,,        ,,   OF U'  (     ,,    )
C
C     OUTPUT : T AND TP=DT/DX
C
C **************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/STPS/H,NMAX,NSTPD,KSTPD(5),NMIN
      DIMENSION BM(3,3),BMP(3,3),BMO(3,3),BMPO(3,3)
      DIMENSION T(3,3),TP(3,3),TI(3,3),TIP(3,3,7),
     ,          AI(3,3),TRANS(3,3),TRAND(3,3),
     ,          A(3,3),AINV(3,3),BMINV(3,3),TIT(3,3)
      DATA ICALL/0/,AI/1.D0,0.D0,0.D0, 0.D0,1.D0,0.D0, 0.D0,0.D0,1.D0/
      DATA TI/9*0.D0/,TIP/63*0.D0/,BMINV/9*0.D0/,ONE/1.D0/,SGNLD/1.D0/
      DATA A /9*0.D0/,AINV/9*0.D0/,TIT/9*0.D0/,ITEST/0/
      SAVE TRANS,TRAND,TI,TIP
C
      IF(INDX.GT.7) GOTO 50
      IF(ICALL.EQ.0.AND.ICH.EQ.1) CALL TRANLP(TRANS,TRAND)
      IF(ICALL.EQ.0.AND.ICH.EQ.2) CALL TRANLN(TRANS,TRAND)
      ICALL=1
C
C     DEFINITION : T= UNIT MATRIX AT X=XA(NMAX),.....,XA(NMAX-6)
C
       DO 10 K=1,6
        KKK=7-K
         DO 10 I=1,3
          DO 10 J=1,3
10         TIP(I,J,KKK+1)=TIP(I,J,KKK)
      DET=BM(1,1)*BM(2,2)-BM(1,2)*BM(2,1)
      SGNLD=DSIGN(ONE,DET)
      BMINV(1,1)=BM(2,2)/DET
      BMINV(2,2)=BM(1,1)/DET
      BMINV(1,2)=-BM(1,2)/DET
      BMINV(2,1)=-BM(2,1)/DET
      BMINV(3,3)=1.D0/BM(3,3)
      CALL MULTM(BMINV,BMP,1)
      DO 11 I=1,2
      DO 11 J=1,2
 11   TI(I,J)=AI(I,J)
C
      DO 12 I=1,2
      DO 12 J=1,2
      TIP(I,J,1)=0.D0
      DO 13 K=1,2
13    TIP(I,J,1)=TIP(I,J,1)-0.5D0*BMINV(I,K)*TI(K,J)
12    CONTINUE
C
      TI(3,3)=1.0D0/DSQRT(BM(3,3))
      TIP(3,3,1)=-0.5D0*TI(3,3)**3*BMP(3,3)
      GOTO 100
C
50    ID=0
      HH=H
      IX=NMAX+2-INDX
      DO 500 II=1,NSTPD
      IF(IX.EQ.(KSTPD(II)-1)) ID=1
500   IF(IX.GT.KSTPD(II)) HH=2.D0*HH
      IF(ID.NE.1) GOTO 510
C
C     ADAPTIONS AFTER HALVING THE STEPSIZE : INTERPOLATION
C
      CALL INTPOL(IX,TIP,HH,7)
C
510   DET=BM(1,1)*BM(2,2)-BM(1,2)*BM(2,1)
      SGNNW=DSIGN(ONE,DET)
      IF(SGNNW.NE.SGNLD) PRINT 512, DET
512   FORMAT(/,' GREEN, WARNING: SIGN CHANGE IN DETERMINANT BM=',D12.5)
      BMINV(1,1)=BM(2,2)/DET
      BMINV(2,2)=BM(1,1)/DET
      BMINV(1,2)=-BM(1,2)/DET
      BMINV(2,1)=-BM(2,1)/DET
      BMINV(3,3)=1.D0/BM(3,3)
      CALL MULTM(BMINV,BMP,1)
      IF(ITEST.EQ.0) GOTO 35
      DO 39 I=1,3
      DO 38 J=1,3
  38  A(I,J)=0.5D0*BMINV(I,J)
  39  IF(ITEST.NE.0) PRINT 37,(A(I,J),J=1,3)
  37  FORMAT(/,' DT/DY=A * T , A =',3(D12.5,2X))
      DETA=(A(1,1)*A(2,2)-A(1,2)*A(2,1))*A(3,3)
      VALU1=A(1,1)+A(2,2)+DSQRT((A(1,1)-A(2,2))**2+4*A(1,2)*A(2,1))
      VALU2=A(1,1)+A(2,2)-DSQRT((A(1,1)-A(2,2))**2+4*A(1,2)*A(2,1))
      IF(ITEST.NE.0) PRINT 36, DETA,VALU1,VALU2,A(3,3)
  36  FORMAT(/,' DETERMINANT A =',D12.5,' EIGENVALUES : VALU1= ',D12.5,
     ,         '  VALU2= ',D12.5,'  VALU3= ',D12.5,/)
C
  35  DO 51 I=1,3
      DO 51 J=1,3
      AINV(I,J)=AI(I,J)
  51  A(I,J)=AI(I,J)-251.D0*HH*BMINV(I,J)/1440.D0
      DET=A(1,1)*A(2,2)-A(1,2)*A(2,1)
      AINV(1,1)=A(2,2)/DET
      AINV(2,2)=A(1,1)/DET
      AINV(1,2)=-A(1,2)/DET
      AINV(2,1)=-A(2,1)/DET
      DO 52 I=1,2
      DO 52 J=1,2
  52  TI(I,J)=TI(I,J)-HH*(646.D0*TIP(I,J,1)-264.D0*TIP(I,J,2)+
     2                    106.D0*TIP(I,J,3)- 19.D0*TIP(I,J,4))/720.D0
      TI(3,3)=1.0D0/DSQRT(BM(3,3))
      CALL MULTM(AINV,TI,2)
C
      KK=6
       DO 53 K=1,KK
        KKK=KK-K+1
         DO 53 I=1,3
          DO 53 J=1,3
53         TIP(I,J,KKK+1)=TIP(I,J,KKK)
      DO 54 I=1,2
       DO 54 J=1,2
        TIP(I,J,1)=0.D0
         DO 54 K=1,2
54        TIP(I,J,1)=TIP(I,J,1)-
     -               0.5D0*BMINV(I,K)*TI(K,J)
C
       TIP(3,3,1)=-0.5D0*TI(3,3)**3*BMP(3,3)
C
100   DO 101 I=1,3
      DO 101 J=1,3
      II=I
      JJ=J
      IF(I.EQ.3) II=2
      IF(J.EQ.3) JJ=2
C     PARTICLE BASIS:
      BMO (I,J)=TRANS(I,J)*BM  (II,JJ)  +TRAND(I,J)*BM (3,3)
      BMPO(I,J)=TRANS(I,J)*BMP (II,JJ)  +TRAND(I,J)*BMP(3,3)
*     T  (I,J)=TRANS(I,J)*TI  (II,JJ)  +TRAND(I,J)*TI(3,3)
*     TP (I,J)=TRANS(I,J)*TIP (II,JJ,1)+TRAND(I,J)*TIP(3,3,1)
C     SU(2)-BASIS:
      T  (I,J)= TI  (I,J)  
      TP (I,J)= TIP (I,J,1)
101   CONTINUE
C     DO 3000 I=1,3
C3000 PRINT 3001 , (T  (I,J),J=1,3)
C3001 FORMAT(/,'  GREEN TGR=',3(D12.5,3X))
C     DO 4000 I=1,3
C4000 PRINT 4001 , (TP (I,J),J=1,3)
C4001 FORMAT(/,'  GREEN TGRP=',3(D12.5,3X))
C
      IF(ITEST.EQ.0) RETURN
      DO 6000 I=1,3
 6000 PRINT 6001 , (TI(I,J),J=1,3),(TIP(I,J,1),J=1,3)
 6001 FORMAT(/,'  GREEN TI =',3(D12.5,3X),' TIP =',3(D12.5,3X))
C
      ADIA1=(BM(1,1)-1.D0)/2.D0
      ADIA2=(BM(2,2)-1.D0)/2.D0
      AOFF=BM(1,2)/2.D0
      A33=(BM(3,3)-1.D0)/2.D0
      T11=1.D0/DSQRT(1.D0+2.D0*(ADIA1-AOFF))
      T22=1.D0/DSQRT(1.D0+2.D0*(ADIA2+AOFF))
      GOTO (401,402),ITEST
  401 TIT(1,1)=T11
      TIT(2,2)=T22
      TIT(1,2)=0.D0
      TIT(2,1)=0.D0
      GOTO 400
  402 TIT(1,1)=(T22+T11)/2.D0
      TIT(1,2)=(T22-T11)/2.D0
      TIT(2,2)=TIT(1,1)
      TIT(2,1)=TIT(1,2)
  400 TIT(3,3)=1.D0/DSQRT(1.D0+2*A33)
      DO 7000 I=1,3
 7000 PRINT 7001 , (TIT(I,J),J=1,3),ITEST
 7001 FORMAT(/,' GREEN TIT =',3(D12.5,3X),'  ITEST=',I3)
C
      RETURN
      END
C **************************************************************
      SUBROUTINE INVER3(A,B)
      IMPLICIT REAL*8(A-H,O-Z)
C     ******************************************************************
C
C     OUTPUT : MATRIX  B**(-1) * A  (STORED IN LOCATIONS OF: A)
C
      DIMENSION A(3,3),B(3,3)
      N=3
      D=1.0D0
      DO 4 K=1,N
      DIV=B(K,K)
      D=D*DIV
      DO 1 J=1,N
    1 A(K,J)=A(K,J)/DIV
      DO 2 J=K,N
    2 B(K,J)=B(K,J)/DIV
      DO 4 I=1,N
      IF(I.EQ.K) GO TO 4
      DET=B(I,K)
      DO 3 J=K,N
    3 B(I,J)=B(I,J)-DET*B(K,J)
      DO 8 J=1,N
    8 A(I,J)=A(I,J)-DET*A(K,J)
    4 CONTINUE
      DS=D
      IF(DABS(DS).LT.0.1D-15) PRINT 5,D
    5 FORMAT(1X,' DETERMINANT INVER3 =  ',D25.16)
      RETURN
      END
C     ******************************************************************
      SUBROUTINE MULTM(A,B,IS)
      IMPLICIT REAL*8(A-H,O-Z)
C     ******************************************************************
C
C     OUTPUT IS=1 : A * B    ( STORED IN LOCATIONS OF MATRIX:  A )
C              =2 : A * B    ( STORED IN LOCATIONS OF MATRIX:  B )
C
      DIMENSION A(3,3),B(3,3),C(6,6)
      N=3
      DO 1 I=1,N
      DO 1 J=1,N
      C(I,J)=0.D0
      DO 2 K=1,N
    2 C(I,J)=C(I,J)+A(I,K)*B(K,J)
    1 CONTINUE
      DO 3 I=1,N
      DO 3 J=1,N
      IF(IS.EQ.1) THEN
      A(I,J)=C(I,J)
      ELSE
      B(I,J)=C(I,J)
      ENDIF
    3 CONTINUE
      RETURN
      END
C **************************************************************
      SUBROUTINE INTPOL(IXA,TIP,H,N)
C **************************************************************
C     INTERPOLATION AT STEPHALVING POINTS
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION TIP(3,3,7),X(7),Y(7),C(7),A(7,7),B(7,7)
      IF(N.NE.7) GOTO 100
      DO 1 I=1,N
    1 X(I)=(I-1)*2*H
C
      DO 2 I=1,3
      DO 2 J=1,3
*
      DO 3 K=1,N
    3 Y(K)=TIP(I,J,K)
C
C     POLYNOMIAL CONSTRUCTION
C
      DO 10 K=1,N
      DO 10 L=1,N
      A(K,L)=0.D0
      B(K,L)=0.D0
      A(K,K)=1.D0
   10 B(K,K)=1.D0
      DO 20 K=1,N
      XL=1.D0
      DO 21 L=1,N
      A(K,L)=XL
   21 XL=X(K)*XL
   20 CONTINUE
      CALL INVER7(B,A,N)
      DO 40 K=1,N
      C(K)=0.D0
      DO 40 L=1,N
   40 C(K)=C(K)+B(K,L)*Y(L)
C     INTERPOLATION
      TIP(I,J,7)=TIP(I,J,4)
      TIP(I,J,5)=TIP(I,J,3)
      TIP(I,J,3)=TIP(I,J,2)
C
      XK2=1.D0
      XK4=1.D0
      XK6=1.D0
      TIP(I,J,2)=0.D0
      TIP(I,J,4)=0.D0
      TIP(I,J,6)=0.D0
      DO 60 K=1,N
      TIP(I,J,2)=TIP(I,J,2)+C(K)*XK2
      TIP(I,J,4)=TIP(I,J,4)+C(K)*XK4
      TIP(I,J,6)=TIP(I,J,6)+C(K)*XK6
      XK2=XK2*H
      XK4=3*XK4*H
   60 XK6=5*XK6*H
C
C     PRINT RESULTS INTERPOLATION
C
C     PRINT 29, IXA,H,I,J
C  29 FORMAT(//,' IN INTPOL : IXA=',I4,' H=',D12.5,' I=',I1,' J=',I1,/)
C     PRINT 30, (TIP(I,J,K),K=1,7)
C  30 FORMAT(/,' TIP(I,J,K)=',7(D12.5,3X),/)
C
 2    CONTINUE
      RETURN
 100  PRINT 101, N
 101  FORMAT(/,' STOP OCCURRED IN SUBROUTINE INTPOL! REASON :',/,
     2         ' ONLY INTERPOLATION WITH N=7 IS ALLOWED',/,' N=',I3)
      STOP
      END
C     ******************************************************************
      SUBROUTINE INVER7(A,B,N)
      IMPLICIT REAL*8(A-H,O-Z)
C     ******************************************************************
C
C     OUTPUT : MATRIX  B**(-1) * A  (STORED IN LOCATIONS OF: A)
C
      DIMENSION A(7,7),B(7,7)
      IF(N.NE.7) WRITE(*,*) 'WARNING: IN INVER7 N=',N
C     N=7 : this statement not accepted by g77!
      D=1.D0
      DO 4 K=1,N
      DIV=B(K,K)
      D=D*DIV
      DO 1 J=1,N
    1 A(K,J)=A(K,J)/DIV
      DO 2 J=K,N
    2 B(K,J)=B(K,J)/DIV
      DO 4 I=1,N
      IF(I.EQ.K) GO TO 4
      DET=B(I,K)
      DO 3 J=K,N
    3 B(I,J)=B(I,J)-DET*B(K,J)
      DO 8 J=1,N
    8 A(I,J)=A(I,J)-DET*A(K,J)
    4 CONTINUE
      DS=D
*     IF(DABS(DS).LT.0.1D-15) PRINT 5,D
*   5 FORMAT(1X,' DETERMINANT INVER7 =  ',D25.16)
      RETURN
      END
C *******************************************************************
      SUBROUTINE GRNTST(XA,PHI,PHIP,IRET)
*
*     CALLED BY AMATLN FOR CHECKING EIGENVALUES                      
*
*     NOTE THAT HERE : PHI = M-MATRIX=1 + 2 * PHI ETC.
C *******************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PHI(3,3),PHIP(3,3),AI(3,3),
     .          PHI2(2,2),PHIP2(2,2),PHI2D(2,2),PHIDH(2,2)
      DIMENSION O(2,2),OMIN(2,2),U1(2),U2(2)
      DATA AI/1.D0,0.D0,0.D0,0.D0,1.D0,0.D0,0.D0,0.D0,1.D0/
      DATA EPS/1.D-16/,PHI2D/4*0.D0/,PHIDH/4*0.D0/
*     DATA PHIH/5.D0/,PHIL/ 0.2D0/,DPHIH/10.D0/,DPHIL/-10.D0/
      DATA PHIH/5.D0/,PHIL/ 1.0D0/,DPHIH/10.D0/,DPHIL/-10.D0/

c     PRINT 51, XA
c 51  FORMAT(72('*'),/,'  ENTERING GRNTST : XA=',F10.3)
c     DO 2000 I=1,3
c2000 PRINT 2001, (PHI(I,J),J=1,3),(PHIP(I,J),J=1,3)
c2001 FORMAT(/,'  GRNTST PHI=',3(D9.3,1X),'  PHIP=',3(D9.3,1X))
C
      DO 1 I=1,2
      DO 1 J=1,2   
      PHI2(I,J) = PHI(I,J)
*     PHIP2(I,J) = PHIP(I,J)
    1 CONTINUE
C
C     DIAGONALIZATION PHI2:
C
      A = PHI(1,1)
      D = PHI(2,2)
      C = PHI(1,2)
C
C     DECOMPOSITION PHI2-MATRIX: (A+D)/2 + C \SIGMAX + (A-D)/2 \SIGMA3
C                               =(A+D)/2 + ROOT*\SIGMA\CDOT\NVECTOR
C
      ROOT = DSQRT(C**2+0.25D0*(A-D)**2)
      IF(ROOT.LT.EPS) RETURN

      IF(C.NE.0.D0) THEN
C     
C     EIGENVALUES:                
C
      ALMD1 = 0.5D0*(A+D)+ROOT
      ALMD2 = 0.5D0*(A+D)-ROOT

      ENX= C/ROOT
      ENZ= 0.5D0*(A-D)/ROOT
C     EIGENVECTORS: 
      ROOTP = 1.D0/DSQRT(2*(1.D0+ENZ))
      U1(1) = (1.D0+ENZ)*ROOTP
      U1(2) = ENX*ROOTP
      ROOTM = 1.D0/DSQRT(2*(1.D0-ENZ))
      U2(1) = (1.D0-ENZ)*ROOTM
      U2(2) = -ENX*ROOTM
C     
C     DIAGONALIZING TRANSFORMATION:
C
      DO 2 J=1,2
      O(1,J) = U1(J)
      O(2,J) = U2(J)
      OMIN(J,1)= U1(J)
      OMIN(J,2)= U2(J)
    2 CONTINUE
      ENDIF

      IF(C.EQ.0.D0) THEN
      ALMD1 = A
      ALMD2 = D
      DO 20 I=1,2
      DO 20 J=1,2
      O(I,J) = AI(I,J)
      OMIN(I,J)= AI(I,J)
   20 CONTINUE
      ENDIF

      DETPH2=ALMD1*ALMD2
      DETPHI=DETPH2*PHI(3,3)
c     PRINT 3001, ALMD1,ALMD2
c3001 FORMAT(/,'  GRNTST EIGENVALUES: ALMD1=',D9.3,' ALMD2=',D9.3,/)
c     PRINT 3002, DETPH2,DETPHI
c3002 FORMAT(/,'  GRNTST DETERMINANT: DETPH2=',D9.3,' DETPHI=',D9.3,/)
c     DO 3000 I=1,2
c3000 PRINT 3003, (O(I,J),J=1,2),(OMIN(I,J),J=1,2)
c3003 FORMAT(/,' GRNTST O  =',2(D9.3,1X),'  OMIN=',2(D9.3,1X))

C     TEST EIGENVALUES BEFORE GREEN TRANSFORMATION:
      ITEST = 0
      IF(IRET.EQ.0) THEN
      IF(ALMD1.GT.PHIH) ALMD1=PHIH
      IF(ALMD2.GT.PHIH) ALMD2=PHIH
      ENDIF
      IF(ALMD1.LT.PHIL) ALMD1=PHIL
      IF(ALMD2.LT.PHIL) ALMD2=PHIL
      IF(ALMD1.EQ.PHIH.OR.ALMD1.EQ.PHIL) ITEST=1
      IF(ALMD2.EQ.PHIH.OR.ALMD2.EQ.PHIL) ITEST=1
      IF(ITEST.EQ.0) GOTO 7000 

      PHI2D(1,1) = ALMD1
      PHI2D(2,2) = ALMD2

C     CHECK: PHI2D = PHIDH
      DO 3 I=1,2
      DO 3 J=1,2
      PHIDH(I,J) = 0.D0
      DO 4 K=1,2
      DO 4 L=1,2
    4 PHIDH(I,J) = PHIDH(I,J) + O(I,K)*PHI2(K,L)*OMIN(L,J)
    3 CONTINUE
c     DO 4000 I=1,2
c4000 PRINT 4001, (PHI2D(I,J),J=1,2),(PHIDH(I,J),J=1,2)
c4001 FORMAT(/,'  GRNTST PHI2D=',2(D9.3,1X),'  PHIDH=',2(D9.3,1X))
C
C     BACK TRANSFORMATION:
C
      DO 5 I=1,2
      DO 5 J=1,2
      PHI2(I,J) = 0.D0
      DO 6 K=1,2
      DO 6 L=1,2
    6 PHI2(I,J) = PHI2(I,J) + OMIN(I,K)*PHI2D(K,L)*O(L,J)
      PHI (I,J) = PHI2(I,J)
    5 CONTINUE

 7000 IF(PHI(3,3).GT.PHIH) PHI(3,3)=PHIH
      IF(PHI(3,3).LT.PHIL) PHI(3,3)=PHIL
      IF(PHI(3,3).EQ.PHIH.OR.PHI(3,3).EQ.PHIL) ITEST=1
      IF(ITEST.EQ.0) RETURN
      DO 7 I=1,2
      DO 7 J=1,2
    7 PHI(I,J) = PHI2(I,J)

c5010 DO 5000 I=1,3
c5000 PRINT 5001, (PHI(I,J),J=1,3),(PHIP(I,J),J=1,3)
c5001 FORMAT(/,'  GRNTST PHI=',3(D9.3,1X),'  PHIP=',3(D9.3,1X))

c     PRINT 62
c 62  FORMAT('  LEAVING GRNTST . ')
      RETURN
      END
c *******************************************************************
      subroutine intpol3(xcall,i,nmax,xa,grpot,cnpot)
c *******************************************************************
      implicit real*8(a-h,o-z)
      dimension xa(300),grpot(3,3,3),tm(2,2),fun(2)
      dimension cnpot(3,3)
      data method/2/,nch/3/

      x = xcall
      if(xcall.eq.xa(nmax)) x=xa(nmax-2)
      if(x.lt.xa(1).or.x.gt.xa(nmax)) then
      write(*,*) ' x-value out of range for Green transf. !!'
      return
      endif

      do 15 ll=1,nch
      do 15 kk=1,ll 

c *******************************************************************
c     two-point interpolation: f=ay+b
      if(method.eq.1) then
      cnpot(kk,ll) = grpot(kk,ll,1) + (x-xa(i))*
     .                 (grpot(kk,ll,2)-grpot(kk,ll,1))/
     .                 (xa(i+1)-xa(i))
      endif
c *******************************************************************
c     three-point interpolation: f=ay**2+by+c
      if(method.eq.2) then
      cc = grpot(kk,ll,1)
      y2 = xa(i+2)-xa(i)
      y1 = xa(i+1)-xa(i)
      det = (y2-y1)*y1*y2
      tm(1,1) = y1/det
      tm(2,2) = y2**2/det
      tm(1,2) = -y2/det
      tm(2,1) = -y1**2/det
      fun(1) = grpot(kk,ll,3)-cc
      fun(2) = grpot(kk,ll,2)-cc
      aa=0.d0
      bb=0.d0
      do 21 kkk=1,2
      aa = aa + tm(1,kkk)*fun(kkk)
      bb = bb + tm(2,kkk)*fun(kkk)
   21 continue
      y = x-xa(i)
      cnpot(kk,ll) = aa*y**2+bb*y+cc              
      endif
c *******************************************************************

   15 continue

      do 25 kk=1,nch
      do 25 ll=1,kk  
      if(kk.ne.ll) 
     .cnpot(kk,ll) = cnpot(ll,kk)
   25 continue
      return
      end




