**********************************************************************
C
**    SUBROUTINE PSSCA2(NMAX,NLOC,ICSB,P)
      SUBROUTINE PSSCA2(XA,NLOC,ICSB,P)
C
C**********************************************************************

C
C     HEAVY PS-SCALAR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGRTST,IGERST,IFRMF
      COMMON/HVY/HF(11),GT(11),FT(11),FD(11),FV(11)
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
**    COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL   ,VCSS   ,VCLS   ,VCDR ,
     .            VSIGLL ,VSIGSS ,VSIGLS ,VSIGDR ,
     .            VTENLL ,VTENSS ,VTENLS ,VTENDR ,
     .            VSOLL  ,VSOSS  ,VSOLS  ,VSODR ,
     .            VSO2LL ,VSO2SS ,VSO2LS ,VSO2DR ,
     .            VASOLL ,VASOSS ,VASOLS ,VASODR ,
     .            VNNC   ,VNNSIG ,VNNTEN ,VNNSO  ,
     .            FILL   ,FISS   ,FILS   ,FIDR ,
     .            DFILL  ,DFISS  ,DFILS  ,DFIDR ,
     .            FISLL  ,FISSS  ,FISLS  ,FISDR ,
     .            DFISLL ,DFISSS ,DFISLS ,DFISDR,
     .            FITLL  ,FITSS  ,FITLS  ,FITDR ,
     .            DFITLL ,DFITSS ,DFITLS ,DFITDR 
      DIMENSION AMPS(5)
      DATA AMP2,AME2,AMX2,AMK2/1300.D0,1280.D0,1430.D0,1460.D0/
      DATA SR3/1.732051D0/,SRPI/1.772454D0/
C
C   NOTE : PION2(IN=1),ETA2 (IN=2),ETAP2(IN=3),KAON2(IN=4)
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/
     .  1.7724538509D0)/(2.D00*XH*XH*XH)
C
C
      DO 1040 IN=1,4
      GOTO(1051,1052,1053,1054),IN
1051  GPLL = 0.D0                                    
      GPSS= -2. *HF(1)*HF(2)*(AMP2/PIM)**2
      GPLS= -SR3*HF(1)*HF(3)*(AMP2/PIM)**2
      GPDR=      HF(1)*HF(2)*(AMP2/PIM)**2
      AMPS(1)=AMP2
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP8
      GOTO 1056
1052  GPLL=  HF(6)*HF(7)*(AME2/PIM)**2
      GPSS=  HF(6)*HF(8)*(AME2/PIM)**2
      GPLS=  0.
      GPDR=  HF(6)*HF(8)*(AME2/PIM)**2
      AMPS(2)=AME2
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP8
      GOTO 1056
1053  GPLL=  HF(9)*HF(10)*(AMX2/PIM)**2
      GPSS=  HF(9)*HF(11)*(AMX2/PIM)**2
      GPLS=  0.
      GPDR=  HF(9)*HF(11)*(AMX2/PIM)**2
      AMPS(3)=AMX2
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMP1
      GOTO 1056
1054  GPLL=      HF(4)*HF(4)*P*(AMK2/PIM)**2
      GPSS=     -HF(5)*HF(5)*P*(AMK2/PIM)**2
      GPLS= -SR3*HF(4)*HF(5)*P*(AMK2/PIM)**2
      GPDR=    2*HF(5)*HF(5)*P*(AMK2/PIM)**2
      AMPS(4)=AMK2
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) ALAM=ALMKA
      GOTO 1056
C
1056  ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM
      RATM1=AMPS(IN)/ALM1
      RATM2=AMPS(IN)/ALM2
      RATM3=AMPS(IN)/ALM3
      FAC1=AMPS(IN)*AMPS(IN)/(AM(1)*AMY(1))
      FAC2=AMPS(IN)*AMPS(IN)/(AM(1)*AMY(2))
      FAC3=AMPS(IN)*AMPS(IN)/(AM(1)*AMH)
C
**    DO 104 I=2,NMAX
**    X = XA(I)
      X = XA
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMPS(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMPS(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMPS(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMPS(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS(IN)
      FTENLL = FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMPS(IN)
C

      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS(IN)
      FTENSS = FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMPS(IN)
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMPS(IN)
      FTENLS = FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMPS(IN)
C
      FCLL1  = FCLL0  - VKULL*AMPS(IN)
      FCSS1  = FCSS0  - VKUSS*AMPS(IN)
      FCLS1  = FCLS0  - VKULS*AMPS(IN)
C
      IF(IN.NE.5)THEN
        VSIGLL   = VSIGLL  + GPLL*FCLL1/3.D0
        VTENLL   = VTENLL  + GPLL*FTENLL
        VSIGDR   = VSIGDR  + GPDR*FCSS1/3.D0
        VTENDR   = VTENDR  + GPDR*FTENSS
        VSIGSS   = VSIGSS  + GPSS*FCSS1/3.D0
        VTENSS   = VTENSS  + GPSS*FTENSS
      ENDIF
      IF(IN.NE.1)THEN
        VSIGLS   = VSIGLS  + GPLS*FCLS1/3.D0
        VTENLS   = VTENLS  + GPLS*FTENLS
      ENDIF
C
  104 CONTINUE
C
 1040 CONTINUE
C
      RETURN
      END
C**********************************************************************
C
**    SUBROUTINE VECTOR2(NMAX,NLOC,ICSB,P)
      SUBROUTINE VECTOR2(XA,NLOC,ICSB,P)
C
C**********************************************************************
C
C     HEAVY VECTOR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGRTST,IGERST,IFRMF
      COMMON/HVY/HFPS(11),GT(11),FT(11),FD(11),FV(11)
      COMMON/MASSES/PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
**    COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL   ,VCSS   ,VCLS   ,VCDR ,
     .            VSIGLL ,VSIGSS ,VSIGLS ,VSIGDR ,
     .            VTENLL ,VTENSS ,VTENLS ,VTENDR ,
     .            VSOLL  ,VSOSS  ,VSOLS  ,VSODR ,
     .            VSO2LL ,VSO2SS ,VSO2LS ,VSO2DR ,
     .            VASOLL ,VASOSS ,VASOLS ,VASODR ,
     .            VNNC   ,VNNSIG ,VNNTEN ,VNNSO  ,
     .            FILL   ,FISS   ,FILS   ,FIDR ,
     .            DFILL  ,DFISS  ,DFILS  ,DFIDR ,
     .            FISLL  ,FISSS  ,FISLS  ,FISDR ,
     .            DFISLL ,DFISSS ,DFISLS ,DFISDR,
     .            FITLL  ,FITSS  ,FITLS  ,FITDR ,
     .            DFITLL ,DFITSS ,DFITLS ,DFITDR 
      DIMENSION AMVC(4),FVC(4),XM1(3),XM2(3)
      DATA AMVC/1450.D0,1420.D0,1680.D0,1410.D0/
      DATA SR3/1.732051D0/,SRPI/1.772454D0/,AMPRO/938.2592D0/
     .    ,FMNL/1.D0/ 
C
C   NOTE : RHO'(IN=1),OME'(IN=2),PHI'(IN=3),KSTAR'(IN=4)
C
C   NOTE : INDEX              1    ,    2    ,    3
C          REFERS TO       LN -> LN, SN -> SN, LN -> SN  REACTION
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
C
      AMKS = AMVC(4)
      PROSLL=-(AM(1)-AMY(1))*(AMY(1)-AM(1))/AMKS/AMKS
      PROSLS=-(AM(1)-AMY(1))*(AMY(2)-AM(1))/AMKS/AMKS
      PROSSS=-(AM(1)-AMY(2))*(AMY(2)-AM(1))/AMKS/AMKS
C
      DO 1040 IN=1,5
      GOTO(1051,1052,1053,1054),IN
1051  GDLL = 0.D0                    
      GDFLL= 0.D0                    
      GFDLL= 0.D0                   
      GFLL = 0.D0                  
      GDSS = -2*FD(1)*FD(2)
      GDFSS= -2*FD(1)*FV(2)
      GFDSS= -2*FV(1)*FD(2)
      GFSS = -2*FV(1)*FV(2)
      GDLS = -FD(1)*FD(3)*SR3
      GDFLS= -FD(1)*FV(3)*SR3
      GFDLS= -FV(1)*FD(3)*SR3
      GFLS = -FV(1)*FV(3)*SR3
      GDDR =  FD(1)*FD(2)
      GDFDR=  FD(1)*FV(2)
      GFDDR=  FV(1)*FD(2)
      GFDR =  FV(1)*FV(2)
      IF(IN.EQ.1) THEN
      XM1(1)=AM(1)
      XM1(2)=AM(1)
      XM1(3)=AM(1)
      XM2(1)=AMY(1)
      XM2(2)=AMY(2)
      XM2(3)=AMH
      ENDIF
      GOTO 1056
1052  GDLL =  FD(6)*FD(7)
      GDFLL=  FD(6)*FV(7)
      GFDLL=  FV(6)*FD(7)
      GFLL =  FV(6)*FV(7)
      GDSS =  FD(6)*FD(8)
      GDFSS=  FD(6)*FV(8)
      GFDSS=  FV(6)*FD(8)
      GFSS =  FV(6)*FV(8)
      GDLS =  0.D0
      GDFLS=  0.D0
      GFDLS=  0.D0
      GFLS =  0.D0
      GDDR =  GDSS
      GDFDR=  GDFSS
      GFDDR=  GFDSS
      GFDR =  GFSS
      GOTO 1056
1053  GDLL =  FD(9)*FD(10)
      GDFLL=  FD(9)*FV(10)
      GFDLL=  FV(9)*FD(10)
      GFLL =  FV(9)*FV(10)
      GDSS =  FD(9)*FD(11)
      GDFSS=  FD(9)*FV(11)
      GFDSS=  FV(9)*FD(11)
      GFSS =  FV(9)*FV(11)
      GDLS =  0.D0
      GDFLS=  0.D0
      GFDLS=  0.D0
      GFLS =  0.D0
      GDDR =  GDSS
      GDFDR=  GDFSS
      GFDDR=  GFDSS
      GFDR =  GFSS
      GOTO 1056
1054  GDLL =  FD(4)*FD(4)*P
      GDFLL=  FD(4)*FV(4)*P
      GFDLL=  FV(4)*FD(4)*P
      GFLL =  FV(4)*FV(4)*P
      GDSS = -FD(5)*FD(5)*P
      GDFSS= -FD(5)*FV(5)*P
      GFDSS= -FV(5)*FD(5)*P
      GFSS = -FV(5)*FV(5)*P
      GDLS = -FD(4)*FD(5)*P*SR3
      GDFLS= -FD(4)*FV(5)*P*SR3
      GFDLS= -FV(4)*FD(5)*P*SR3
      GFLS = -FV(4)*FV(5)*P*SR3
      GDDR = -2*GDSS
      GDFDR= -2*GDFSS
      GFDDR= -2*GFDSS
      GFDR = -2*GFSS
C     CASE IN=4:
      XM1(1)=AMLN
      XM1(2)=AMSN
      XM1(3)=AMLS
      XM2(1)=AMLN
      XM2(2)=AMSN
      XM2(3)=AMLS
C
1056  FVC(IN) = 1.D0
      IF(IMODEL.EQ.1) ALAM=ALMOBE
      IF(IMODEL.GE.2) THEN
       ALAM = ALMV8
       IF(IN.EQ.3) ALAM=ALMV1
       IF(IN.EQ.5) ALAM=ALMKS
      ENDIF
      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM

      RATM1=AMVC(IN)/ALM1
      RATM2=AMVC(IN)/ALM2
      RATM3=AMVC(IN)/ALM3
      FAC0=AMVC(IN)*AMVC(IN)/AMPRO/AMPRO
      FAC1=AMVC(IN)*AMVC(IN)/(XM1(1)*XM2(1))
      FAC2=AMVC(IN)*AMVC(IN)/(XM1(2)*XM2(2))
      FAC3=AMVC(IN)*AMVC(IN)/(XM1(3)*XM2(3))
C
      CCLL1=0.5D0*GDLL*FAC1+(GFDLL/XM1(1)+GDFLL/XM2(1))*AMVC(IN)**2
     .      /(4.*AMPRO)
      CCSS1=0.5D0*GDSS*FAC2+(GFDSS/XM1(2)+GDFSS/XM2(2))*AMVC(IN)**2
     .      /(4.*AMPRO)
      CCLS1=0.5D0*GDLS*FAC3+(GFDLS/XM1(3)+GDFLS/XM2(3))*AMVC(IN)**2
     .      /(4.*AMPRO)
      CCDR1=0.5D0*GDDR*FAC2+(GFDDR/XM1(2)+GDFDR/XM2(2))*AMVC(IN)**2
     .      /(4.*AMPRO)
      CSLL1= GDLL+(GFDLL*XM1(1)+GDFLL*XM2(1)+GFLL*XM1(1)*XM2(1)/AMPRO)
     .       /AMPRO
      CSSS1= GDSS+(GFDSS*XM1(2)+GDFSS*XM2(2)+GFSS*XM1(2)*XM2(2)/AMPRO)
     .       /AMPRO
      CSLS1= GDLS+(GFDLS*XM1(3)+GDFLS*XM2(3)+GFLS*XM1(3)*XM2(3)/AMPRO)
     .       /AMPRO
      CSDR1= GDDR+(GFDDR*XM1(2)+GDFDR*XM2(2)+GFDR*XM1(2)*XM2(2)/AMPRO)
     .       /AMPRO
      CTLL0= CSLL1
      CTSS0= CSSS1
      CTLS0= CSLS1
      CTDR0= CSDR1
      COLL0= 1.5D0*GDLL+(GDFLL+GFDLL)*DSQRT(XM1(1)*XM2(1))/AMPRO
      COSS0= 1.5D0*GDSS+(GDFSS+GFDSS)*DSQRT(XM1(2)*XM2(2))/AMPRO
      COLS0= 1.5D0*GDLS+(GDFLS+GFDLS)*DSQRT(XM1(3)*XM2(3))/AMPRO
      CODR0= 1.5D0*GDDR+(GDFDR+GFDDR)*DSQRT(XM1(2)*XM2(2))/AMPRO
      CO2LL= GDLL+4*(GDFLL+GFDLL)*DSQRT(XM1(1)*XM2(1))/AMPRO +
     +       8*GFLL*XM1(1)*XM2(1)/AMPRO/AMPRO
      CO2SS= GDSS+4*(GDFSS+GFDSS)*DSQRT(XM1(2)*XM2(2))/AMPRO +
     +       8*GFSS*XM1(2)*XM2(2)/AMPRO/AMPRO
      CO2LS= GDLS+4*(GDFLS+GFDLS)*DSQRT(XM1(3)*XM2(3))/AMPRO +
     +       8*GFLS*XM1(3)*XM2(3)/AMPRO/AMPRO
      CO2DR= GDDR+4*(GDFDR+GFDDR)*DSQRT(XM1(2)*XM2(2))/AMPRO +
     +       8*GFDR*XM1(2)*XM2(2)/AMPRO/AMPRO
C
**    DO 104 I=2,NMAX
**    X = XA(I)
      X = XA   
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMVC(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMVC(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMVC(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMVC(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FVC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMVC(IN)
      FTENLL = FVC(IN)*FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSOLL  = FVC(IN)*FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSO2LL = 3*FTENLL/(X*X)
C

      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FVC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMVC(IN)
      FTENSS = FVC(IN)*FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSOSS  = FVC(IN)*FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSO2SS = 3*FTENLL/(X*X)
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FVC(IN)*FF0(EXPM,EX,X,DERFCM,DERFCP)*AMVC(IN)
      FTENLS = FVC(IN)*FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSOLS  = FVC(IN)*FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMVC(IN)
      FSO2LS = 3*FTENLL/(X*X)
C
      FCLL1  = FCLL0  - FVC(IN)*VKULL*AMVC(IN)
      FCSS1  = FCSS0  - FVC(IN)*VKUSS*AMVC(IN)
      FCLS1  = FCLS0  - FVC(IN)*VKULS*AMVC(IN)
      FCLL2  = FCLL1+
     .         FVC(IN)*(1.5D0-XLAM1*XLAM1)*VKULL*AMVC(IN)/RATM1/RATM1
      FCSS2  = FCSS1+
     .         FVC(IN)*(1.5D0-XLAM2*XLAM2)*VKUSS*AMVC(IN)/RATM2/RATM2
      FCLS2  = FCLS1+
     .         FVC(IN)*(1.5D0-XLAM3*XLAM3)*VKULS*AMVC(IN)/RATM3/RATM3
      FTLL1  = FTENLL - FVC(IN)*XLAM1*XLAM1*VKULL*AMVC(IN)
     .                / (3*RATM1*RATM1)
      FTSS1  = FTENSS - FVC(IN)*XLAM2*XLAM2*VKUSS*AMVC(IN)
     .                / (3*RATM2*RATM2)
      FTLS1  = FTENLS - FVC(IN)*XLAM3*XLAM3*VKULS*AMVC(IN)
     .                / (3*RATM3*RATM3)
      FOLL1  = FSOLL  - FVC(IN)*VKULL*AMVC(IN)
     .                / (2*RATM1*RATM1)
      FOSS1  = FSOSS  - FVC(IN)*VKUSS*AMVC(IN)
     .                / (2*RATM2*RATM2)
      FOLS1  = FSOLS  - FVC(IN)*VKULS*AMVC(IN)
     .                / (2*RATM3*RATM3)
C
      VCLL   = VCLL    + GDLL*FCLL0 + CCLL1*FCLL1 +
     .                       GFLL*FAC0*FAC1*FCLL2/16.D0
     .                     + (1-INRS)*FAC1*(GDLL*FAC1/64.D0+(GDFLL
     .                       +GFDLL)*DSQRT(FAC0*FAC1)/16.D0)*FCLL2
      VCSS   = VCSS    + GDSS*FCSS0 + CCSS1*FCSS1 +
     .                       GFSS*FAC0*FAC2*FCSS2/16.D0
     .                     + (1-INRS)*FAC2*(GDSS*FAC2/64.D0+(GDFSS
     .                       +GFDSS)*DSQRT(FAC0*FAC2)/16.D0)*FCSS2
      VCLS   = VCLS    + GDLS*FCLS0 + CCLS1*FCLS1 +
     .                       GFLS*FAC0*FAC3*FCLS2/16.D0
     .                     + (1-INRS)*FAC3*(GDLS*FAC3/64.D0+(GDFLS
     .                       +GFDLS)*DSQRT(FAC0*FAC3)/16.D0)*FCLS2
      VCDR   = VCDR    + GDDR*FCSS0 + CCDR1*FCSS1 +
     .                       GFDR*FAC0*FAC2*FCSS2/16.D0
     .                     + (1-INRS)*FAC2*(GDDR*FAC2/64.D0+(GDFDR
     .                       +GFDDR)*DSQRT(FAC0*FAC2)/16.D0)*FCSS2
C
      VSIGLL = VSIGLL  + (CSLL1*FCLL1 + INRS*GFLL*FAC0*FCLL2/8.D0)
     .                     * FAC1/6.D0
      VSIGSS = VSIGSS  + (CSSS1*FCSS1 + INRS*GFSS*FAC0*FCSS2/8.D0)
     .                     * FAC2/6.D0
      VSIGLS = VSIGLS  + (CSLS1*FCLS1 + INRS*GFLS*FAC0*FCLS2/8.D0)
     .                     * FAC3/6.D0
      VSIGDR = VSIGDR  + (CSDR1*FCSS1 + INRS*GFDR*FAC0*FCSS2/8.D0)
     .                     * FAC2/6.D0
C
      VTENLL = VTENLL  - (CTLL0*FTENLL + INRS*GFLL*FAC0*FTLL1/8.D0)
     .                     * FAC1/4.D0
      VTENSS = VTENSS  - (CTSS0*FTENSS + INRS*GFSS*FAC0*FTSS1/8.D0)
     .                     * FAC2/4.D0
      VTENLS = VTENLS  - (CTLS0*FTENLS + INRS*GFLS*FAC0*FTSS1/8.D0)
     .                     * FAC3/4.D0
      VTENDR = VTENDR  - (CTDR0*FTENSS + INRS*GFDR*FAC0*FTSS1/8.D0)
     .                     * FAC2/4.D0
C
      VSOLL  = VSOLL   - (COLL0*FSOLL + GFLL*FAC0*FOLL1*3/8.D0)
     .                     * FAC1
      VSOSS  = VSOSS   - (COSS0*FSOSS + GFSS*FAC0*FOSS1*3/8.D0)
     .                     * FAC2
      VSOLS  = VSOLS   - (COLS0*FSOLS + GFLS*FAC0*FOLS1*3/8.D0)
     .                     * FAC3
      VSODR  = VSODR   - (CODR0*FSOSS + GFDR*FAC0*FOSS1*3/8.D0)
     .                     * FAC2
C
      VSO2LL = VSO2LL  + CO2LL*FSO2LL*FAC1*FAC1/16.D0
      VSO2SS = VSO2SS  + CO2SS*FSO2SS*FAC2*FAC2/16.D0
      VSO2LS = VSO2LS  + CO2LS*FSO2LS*FAC3*FAC3/16.D0
      VSO2DR = VSO2DR  + CO2DR*FSO2SS*FAC2*FAC2/16.D0
      IF(IN.NE.5) GOTO 105
C
C     K-STAR : CONTRIBUTION SECOND TERM IN VECTOR MESON PROPAGATOR
C
      VCLL  = VCLL  - GDLL*PROSLL*FCLL0*(1.D0-FAC1/4.D0)
      VCSS  = VCSS  - GDSS*PROSSS*FCSS0*(1.D0-FAC2/4.D0)
      VCLS  = VCLS  - GDLS*PROSLS*FCLS0*(1.D0-FAC3/4.D0)
      VCDR  = VCDR  - GDDR*PROSSS*FCSS0*(1.D0-FAC2/4.D0)
C
      VSOLL  = VSOLL  - GDLL*PROSLL*FSOLL*FAC1/2.D0
      VSOSS  = VSOSS  - GDSS*PROSSS*FSOSS*FAC2/2.D0
      VSOLS  = VSOLS  - GDLS*PROSLS*FSOLS*FAC3/2.D0
      VSODR  = VSODR  - GDDR*PROSSS*FSOSS*FAC2/2.D0
C
      VSO2LL  = VSO2LL  - GDLL*PROSLL*FSO2LL*FAC1*FAC1/16.D0
      VSO2SS  = VSO2SS  - GDSS*PROSSS*FSO2SS*FAC2*FAC2/16.D0
      VSO2LS  = VSO2LS  - GDLS*PROSLS*FSO2LS*FAC3*FAC3/16.D0
      VSO2DR  = VSO2DR  - GDDR*PROSSS*FSO2SS*FAC2*FAC2/16.D0
C
105   IF(NLOC.EQ.0) GOTO 104
      FILL   = FILL    + 1.5D0*REDMM*GDLL*FCLL0/(XM1(1)*XM2(1))
      FISS   = FISS    + 1.5D0*REDMM*GDSS*FCSS0/(XM1(2)*XM2(2))
      FILS   = FILS    + 1.5D0*REDMM*GDLS*FCLS0/(XM1(3)*XM2(3))
      FIDR   = FIDR    + 1.5D0*REDMM*GDDR*FCSS0/(XM1(2)*XM2(2))
C
      DFILL =DFILL -1.5D0*REDMM*GDLL*FSOLL*X*FAC1/AMVC(IN)
      DFISS =DFISS -1.5D0*REDMM*GDSS*FSOSS*X*FAC2/AMVC(IN)
      DFILS =DFILS -1.5D0*REDMM*GDLS*FSOLS*X*FAC3/AMVC(IN)
      DFIDR =DFIDR -1.5D0*REDMM*GDDR*FSOSS*X*FAC2/AMVC(IN)
C
  104 CONTINUE
C
 1040 CONTINUE
C
      RETURN
      END
C**********************************************************************
**    SUBROUTINE AXIAL(NMAX,NLOC,ICSB,P)
      SUBROUTINE AXIAL(XA,ICSB,NLOC,LC,P)
C
C**********************************************************************
C     VERSION AUGUST 2004: WITH OPTION OF A ZERO IN FORM-FACTOR
C                          CORRECTED DERIVATIVES
C**********************************************************************
C
C     AXIAL MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C
C     IN MOMENTUM SPACE AXIAL-EXCHANGE:                         
C
C     FIRST TERM PROPAGATOR:
C     V_A^(1) = -GA2*[[(1+(Q2+K2/4)/(6M'M)](SIGMA1.SIGMA2)+
C                     +(2/M'M)[(SIGMA1.Q)(SIGMA2.Q)-Q2(SIGMA1.SIGMA2)/3]
C                     -(1/4M'M)[(SIGMA1.K)(SIGMA2.K)-K2(SIGMA1.SIGMA2)/3]
C                     +(i/4M'M)(SIGMA1+SIGMA2).QXK ]]/(K2+MA2)
C
C     APPROXIMATION: FROM Q-TENSOR TERM: ONLY LOCAL CONTRIBUTION KEPT!
C                    ------------------------------------------------
C
C   NOTE : A1(1270)(IN=1),D=F1(1285)(IN=2),E=F1(1420)(IN=3)
C
C   COUPLING: A LA CHIRAL LAGR., SEE STOKS & RIJKEN (NUCL.PHYS. A613 (1997))    
C
C   PROPAGATOR OPTIONS: A) PROCA,IBFLD=0, B) B-FIELD FORMALISM, IBFLD=1
C**********************************************************************
C
C   THE POTENTIAL FUNCTIONS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGRTST,IGERST,IFRMF
      COMMON/ZEROS/IZPS,IZVC,IZSC,IZAX,IZTEN
      COMMON/ALLAX/FA(11),FB(11),ALMAX                           
      COMMON/MASSES/ PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
**    COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL   ,VCSS   ,VCLS   ,VCDR   ,
     .            VSIGLL ,VSIGSS ,VSIGLS ,VSIGDR ,
     .            VTENLL ,VTENSS ,VTENLS ,VTENDR ,
     .            VSOLL  ,VSOSS  ,VSOLS  ,VSODR  ,
     .            VSO2LL ,VSO2SS ,VSO2LS ,VSO2DR ,
     .            VASOLL ,VASOSS ,VASOLS ,VASODR ,
     .            VNNC   ,VNNSIG ,VNNTEN ,VNNSO  ,
     .            FILL   ,FISS   ,FILS   ,FIDR   ,
     .            DFILL  ,DFISS  ,DFILS  ,DFIDR  ,
     .            FISLL  ,FISSS  ,FISLS  ,FISDR  ,
     .            DFISLL ,DFISSS ,DFISLS ,DFISDR ,
     .            FITLL  ,FITSS  ,FITLS  ,FITDR ,
     .            DFITLL ,DFITSS ,DFITLS ,DFITDR 
      DIMENSION AMAX(4)
      DATA SR3/1.732051D0/,SRPI/1.772454D0/
**    DATA AMA1,AMD1,AME1,AMK1/1270.D0,1285.D0,1420.D0,1273.D0/
      DATA AMA1,AMD1,AME1,AMK1/1270.D0,1285.D0,1420.D0,1400.D0/
      DATA IBFLD/0/,ICALL/0/,FZERO/0.D0/,AMCRA/750.D0/

      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/
     .  1.7724538509D0)/(2.D00*XH*XH*XH)
C
      IF(ICALL.EQ.0) THEN
      WRITE(*,*) ' AXIAL.02: IBFLD=',IBFLD
      ICALL=1
      ENDIF

      DIV1 =1.D0/(AM(1)*AMY(1))
      DIV2 =1.D0/(AM(1)*AMY(2))
      DIV3 =1.D0/(AM(1)*AMH   )
      DO 1040 IN=1,4
      GOTO(1051,1052,1053,1054),IN
1051  GALL= 0.D0   
      GASS= -2*FA(1)*FA(2)
      GALS= -SR3*FA(1)*FA(3)
      GADR= FA(1)*FA(2)
      AMAX(1)=AMA1
      GOTO 1055
1052  GALL=  FA(6)*FA(7)
      GASS=  FA(6)*FA(8)  
      GALS=  0.D0
      GADR=  FA(6)*FA(8)  
      AMAX(2)=AME1
      GOTO 1055
1053  GALL=  FA(9)*FA(10)
      GASS=  FA(9)*FA(11)
      GALS=  0.D0
      GADR=  FA(9)*FA(11)
      AMAX(3)=AMD1
      GOTO 1055
1054  GALL=  FA(4)*FA(4)*P
      GASS= -FA(5)*FA(5)*P
      GALS= -SR3*FA(4)*FA(5)*P
      GADR= 2*FA(5)*FA(5)*P
      AMAX(4)=AMK1
C
1055  IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN      
      ALAM = ALMAX
      IF(ALAM.EQ.0.D0) ALAM=ALMP8
      IF(IN.EQ.2.AND.ALMAX.EQ.0.D0) ALAM=ALMP1
      IF(IN.EQ.4.AND.ALMAX.EQ.0.D0) ALAM=ALMKA
      ENDIF

      ALM1=ALAM
      ALM2=ALAM
      ALM3=ALAM
      RATM1=AMAX(IN)/ALM1
      RATM2=AMAX(IN)/ALM2
      RATM3=AMAX(IN)/ALM3
      FAC1 =AMAX(IN)**2/(AM(1)*AMY(1))
      FAC2 =AMAX(IN)**2/(AM(1)*AMY(2))
      FAC3 =AMAX(IN)**2/(AM(1)*AMH   )
      IF(IZAX.NE.0) FZERO = (AMAX(IN)/AMCRA)**2
C
**    DO 104 I=2,NMAX
**    X = XA(I)
      X = XA   
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMAX(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMAX(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMAX(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMAX(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLL0  = FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLL0 = FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLL1  = FCLL0  - VKULL*AMAX(IN)
      DFCLL0 = -FSOLL0*XA*AMAX(IN)**2/PIM
      DFCLL1 =  DFCLL0 + ALM1*XLAM1*VKULL*AMAX(IN)     
      DFTLL0 =  DFCLL1/3.D0-3*FTLL0*PIM/XA
C
      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTSS0  = FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOSS0 = FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCSS1  = FCSS0  - VKUSS*AMAX(IN)
      DFCSS0 = -FSOSS0*XA*AMAX(IN)**2/PIM
      DFCSS1 =  DFCSS0 + ALM2*XLAM2*VKUSS*AMAX(IN)     
      DFTSS0 =  DFCSS1/3.D0-3*FTSS0*PIM/XA
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLS0  = FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLS0 = FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLS1  = FCLS0  - VKULS*AMAX(IN)
      DFCLS0 = -FSOLS0*XA*AMAX(IN)**2/PIM
      DFCLS1 =  DFCLS0 + ALM3*XLAM3*VKULS*AMAX(IN)     
      DFTLS0 =  DFCLS1/3.D0-3*FTLS0*PIM/XA

      IF(IZAX.NE.0) THEN
      FCLL2  = FCLL1 + (1.5D0-XLAM1*XLAM1)
     .               * VKULL*AMAX(IN)/RATM1/RATM1
      DFCLL2 = DFCLL1 -ALM1*XLAM1*(2.5D0-XLAM1*XLAM1)
     .               * VKULL*AMAX(IN)/RATM1/RATM1
      FTLL1  = FTLL0 - XLAM1*XLAM1*VKULL*AMAX(IN)/(3*RATM1*RATM1)
      DFTLL1 = DFTLL0- ALM1*XLAM1*(1D0-XLAM1*XLAM1)
     .               * VKULL*AMAX(IN)/(3*RATM1*RATM1)
      FSOLL1 = FSOLL0 - 0.5D0*(ALM1/AMAX(IN))**2*VKULL*AMAX(IN)

      FCSS2  = FCSS1 + (1.5D0-XLAM2*XLAM2)
     .               * VKUSS*AMAX(IN)/RATM2/RATM2
      DFCSS2 = DFCSS1 -ALM2*XLAM2*(2.5D0-XLAM2*XLAM2)
     .               * VKUSS*AMAX(IN)/RATM2/RATM2
      FTSS1  = FTSS0 - XLAM2*XLAM2*VKUSS*AMAX(IN)/(3*RATM2*RATM2)
      DFTSS1 = DFTSS0- ALM2*XLAM2*(1D0-XLAM2*XLAM2)
     .               * VKUSS*AMAX(IN)/(3*RATM2*RATM2)
      FSOSS1 = FSOSS0 - 0.5D0*(ALM2/AMAX(IN))**2*VKUSS*AMAX(IN)

      FCLS2  = FCLS1 + (1.5D0-XLAM3*XLAM3)
     .               * VKULS*AMAX(IN)/RATM3/RATM3
      DFCLS2 = DFCLS1 -ALM3*XLAM3*(2.5D0-XLAM3*XLAM3)
     .               * VKULS*AMAX(IN)/RATM3/RATM3
      FTLS1  = FTLS0 - XLAM3*XLAM3*VKUSS*AMAX(IN)/(3*RATM3*RATM3)
      DFTLS1 = DFTLS0- ALM3*XLAM3*(1D0-XLAM3*XLAM3)
     .               * VKULS*AMAX(IN)/(3*RATM3*RATM3)
      FSOLS1 = FSOLS0 - 0.5D0*(ALM3/AMAX(IN))**2*VKULS*AMAX(IN)

C*    NO K^4-TERMS:
      FCLL2  = 0D0
      FCSS2  = 0D0
      FCLS2  = 0D0
      DFCLL2 = 0D0
      DFCSS2 = 0D0
      DFCLS2 = 0D0
      ENDIF
C---------------------------------------------------------------
C
C     FIRST TERM AXIAL PROPAGATOR:
C
C---------------------------------------------------------------
      VSIGLL  = VSIGLL  - GALL*FCLL0 
      VSIGSS  = VSIGSS  - GASS*FCSS0 
      VSIGLS  = VSIGLS  - GALS*FCLS0 
      VSIGDR  = VSIGDR  - GADR*FCSS0 

      VTENLL  = VTENLL  - 0.75D0*GALL*FAC1 *FTLL0
      VTENSS  = VTENSS  - 0.75D0*GASS*FAC2 *FTSS0
      VTENLS  = VTENLS  - 0.75D0*GALS*FAC3 *FTLS0
      VTENDR  = VTENDR  - 0.75D0*GADR*FAC2 *FTSS0

      VSOLL   = VSOLL   - 0.5D0*GALL*FAC1 *FSOLL0
      VSOSS   = VSOSS   - 0.5D0*GASS*FAC2 *FSOSS0
      VSOLS   = VSOLS   - 0.5D0*GALS*FAC3 *FSOLS0
      VSODR   = VSODR   - 0.5D0*GADR*FAC2 *FSOSS0

      FISLL   = FISLL   - GALL*FCLL0*DIV1*REDM(1)/6.D0
      FISSS   = FISSS   - GASS*FCSS0*DIV2*REDM(2)/6.D0
      FISLS   = FISLS   - GALS*FCLS0*DIV3*REDM(3)/6.D0
      FISDR   = FISDR   - GADR*FCSS0*DIV2*REDM(2)/6.D0

      DFISLL  = DFISLL  - GALL*DFCLL0*DIV1*REDM(1)/6.D0
      DFISSS  = DFISSS  - GASS*DFCSS0*DIV2*REDM(2)/6.D0
      DFISLS  = DFISLS  - GALS*DFCLS0*DIV3*REDM(3)/6.D0
      DFISDR  = DFISDR  - GADR*DFCSS0*DIV2*REDM(2)/6.D0
C---------------------------------------------------------------
      IF(IZAX.NE.0) THEN
      VSIGLL  = VSIGLL  - FZERO*GALL*FCLL1 
      VSIGSS  = VSIGSS  - FZERO*GASS*FCSS1 
      VSIGLS  = VSIGLS  - FZERO*GALS*FCLS1 
      VSIGDR  = VSIGDR  - FZERO*GADR*FCSS1 

      VTENLL  = VTENLL  - 0.75D0*FZERO*GALL*FAC1 *FTLL1
      VTENSS  = VTENSS  - 0.75D0*FZERO*GASS*FAC2 *FTSS1
      VTENLS  = VTENLS  - 0.75D0*FZERO*GALS*FAC3 *FTLS1
      VTENDR  = VTENDR  - 0.75D0*FZERO*GADR*FAC2 *FTSS1

      VSOLL   = VSOLL   - 0.5D0*FZERO*GALL*FAC1 *FSOLL1
      VSOSS   = VSOSS   - 0.5D0*FZERO*GASS*FAC2 *FSOSS1
      VSOLS   = VSOLS   - 0.5D0*FZERO*GALS*FAC3 *FSOLS1
      VSODR   = VSODR   - 0.5D0*FZERO*GADR*FAC2 *FSOSS1

      FISLL   = FISLL   - FZERO*GALL*FCLL1*DIV1*REDM(1)/6.D0
      FISSS   = FISSS   - FZERO*GASS*FCSS1*DIV2*REDM(2)/6.D0
      FISLS   = FISLS   - FZERO*GALS*FCLS1*DIV3*REDM(3)/6.D0
      FISDR   = FISDR   - FZERO*GADR*FCSS1*DIV2*REDM(2)/6.D0

      DFISLL  = DFISLL  - FZERO*GALL*DFCLL1*DIV1*REDM(1)/6.D0
      DFISSS  = DFISSS  - FZERO*GASS*DFCSS1*DIV2*REDM(2)/6.D0
      DFISLS  = DFISLS  - FZERO*GALS*DFCLS1*DIV3*REDM(3)/6.D0
      DFISDR  = DFISDR  - FZERO*GADR*DFCSS1*DIV2*REDM(2)/6.D0
      ENDIF
C---------------------------------------------------------------
c     presumably wrong:
      IF(IZAX.EQ.-1) THEN
      VSIGLL  = VSIGLL  - FZERO*GALL*(FCLL1 + 2*FAC1*FCLL2/3D0)
      VSIGSS  = VSIGSS  - FZERO*GASS*(FCSS1 + 2*FAC2*FCSS2/3D0)
      VSIGLS  = VSIGLS  - FZERO*GALS*(FCLS1 + 2*FAC3*FCLS2/3D0)
      VSIGDR  = VSIGDR  - FZERO*GADR*(FCSS1 + 2*FAC2*FCSS2/3D0)

      VTENLL  = VTENLL  + 0.25D0*FZERO*GALL*FAC1 *FTLL1
      VTENSS  = VTENSS  + 0.25D0*FZERO*GASS*FAC2 *FTSS1
      VTENLS  = VTENLS  + 0.25D0*FZERO*GALS*FAC3 *FTLS1
      VTENDR  = VTENDR  + 0.25D0*FZERO*GADR*FAC2 *FTSS1

      VSOLL   = VSOLL   - 0.5D0*FZERO*GALL*FAC1 *FSOLL1
      VSOSS   = VSOSS   - 0.5D0*FZERO*GASS*FAC2 *FSOSS1
      VSOLS   = VSOLS   - 0.5D0*FZERO*GALS*FAC3 *FSOLS1
      VSODR   = VSODR   - 0.5D0*FZERO*GADR*FAC2 *FSOSS1

      FISLL   = FISLL   - FZERO*3*GALL*FCLL1*DIV1*REDM(1)/2.D0
      FISSS   = FISSS   - FZERO*3*GASS*FCSS1*DIV2*REDM(2)/2.D0
      FISLS   = FISLS   - FZERO*3*GALS*FCLS1*DIV3*REDM(3)/2.D0
      FISDR   = FISDR   - FZERO*3*GADR*FCSS1*DIV2*REDM(2)/2.D0

      DFISLL  = DFISLL  - FZERO*3*GALL*DFCLL1*DIV1*REDM(1)/2.D0
      DFISSS  = DFISSS  - FZERO*3*GASS*DFCSS1*DIV2*REDM(2)/2.D0
      DFISLS  = DFISLS  - FZERO*3*GALS*DFCLS1*DIV3*REDM(3)/2.D0
      DFISDR  = DFISDR  - FZERO*3*GADR*DFCSS1*DIV2*REDM(2)/2.D0
      ENDIF
C---------------------------------------------------------------
C
C     SECOND TERM AXIAL PROPAGATOR:
C
C---------------------------------------------------------------
      IF(IBFLD.EQ.0) THEN
C---------------------------------------------------------------
      VSIGLL  = VSIGLL  + GALL*FCLL1/3
      VSIGSS  = VSIGSS  + GASS*FCSS1/3
      VSIGLS  = VSIGLS  + GALS*FCLS1/3
      VSIGDR  = VSIGDR  + GADR*FCSS1/3

      VTENLL  = VTENLL  + GALL*FTLL0
      VTENSS  = VTENSS  + GASS*FTSS0
      VTENLS  = VTENLS  + GALS*FTLS0
      VTENDR  = VTENDR  + GADR*FTSS0

      FISLL   = FISLL   - GALL*REDM(1)*FCLL1*DIV1/6.D0
      FISSS   = FISSS   - GASS*REDM(2)*FCSS1*DIV2/6.D0
      FISLS   = FISLS   - GALS*REDM(3)*FCLS1*DIV3/6.D0
      FISDR   = FISDR   - GADR*REDM(2)*FCSS1*DIV2/6.D0

      DFISLL  = DFISLL  - GALL*REDM(1)*DFCLL1*DIV1/6.D0
      DFISSS  = DFISSS  - GASS*REDM(2)*DFCSS1*DIV2/6.D0
      DFISLS  = DFISLS  - GALS*REDM(3)*DFCLS1*DIV3/6.D0
      DFISDR  = DFISDR  - GADR*REDM(2)*DFCSS1*DIV2/6.D0

*     FITEN     = FITEN  - GAX2*REDM*FT0 *DIV/2.D0
*     DFITEN    = DFITEN - GAX2*REDM*DFT0*DIV/2.D0
      ENDIF
      if(i.eq.-2) then
      if(in.eq.1) vsll=0.d0
      if(in.eq.1) vsls=0.d0
      if(in.eq.1) vsss=0.d0
      write(*,*) 'axial: in=',in,' i=',i,' xa=',xa,
     .' amax=',amax(in)
      write(*,*) ' gall,gals,gass=',gall,gals,gass
      write(*,*) ' fcll0,fcls0,fcss0=',fcll0,fcls0,fcss0
      write(*,*) ' fcll1,fcls1,fcss1=',fcll1,fcls1,fcss1
      vsll0     =  - GALL*FCLL0 
      vsls0     =  - GALS*FCLS0 
      vsss0     =  - GASS*FCSS0 
      vsll1     =  + GALL*FCLL1/3
      vsls1     =  + GALS*FCLS1/3
      vsss1     =  + GASS*FCSS1/3
      write(*,*) ' vsll0,vsls0,vsss0=',vsll0,vsls0,vsss0  
      write(*,*) ' vsll1,vsls1,vsss1=',vsll1,vsls1,vsss1  
      vsll = vsll+vsll0+vsll1
      vsls = vsls+vsls0+vsls1
      vsss = vsss+vsss0+vsss1
      if(in.eq.4) write(*,*) 'tot: vsll,vsls,vsss=',vsll,vsls,vsss
      endif
C---------------------------------------------------------------
      IF(IZAX.NE.0) THEN
      VSIGLL  = VSIGLL  + FZERO*GALL*FCLL2/3D0
      VSIGSS  = VSIGSS  + FZERO*GASS*FCSS2/3D0
      VSIGLS  = VSIGLS  + FZERO*GALS*FCLS2/3D0
      VSIGDR  = VSIGDR  + FZERO*GADR*FCSS2/3D0

      VTENLL  = VTENLL  + FZERO*GALL*FTLL1
      VTENSS  = VTENSS  + FZERO*GASS*FTSS1
      VTENLS  = VTENLS  + FZERO*GALS*FTLS1
      VTENDR  = VTENDR  + FZERO*GADR*FTSS1

      IF(IZAX.EQ.2) THEN
      FISLL   = FISLL   - FZERO*GALL*REDM(1)*FCLL2*DIV1/6.D0
      FISSS   = FISSS   - FZERO*GASS*REDM(2)*FCSS2*DIV2/6.D0
      FISLS   = FISLS   - FZERO*GALS*REDM(3)*FCLS2*DIV3/6.D0
      FISDR   = FISDR   - FZERO*GADR*REDM(2)*FCSS2*DIV2/6.D0

      DFISLL  = DFISLL  - FZERO*GALL*REDM(1)*DFCLL2*DIV1/6.D0
      DFISSS  = DFISSS  - FZERO*GASS*REDM(2)*DFCSS2*DIV2/6.D0
      DFISLS  = DFISLS  - FZERO*GALS*REDM(3)*DFCLS2*DIV3/6.D0
      DFISDR  = DFISDR  - FZERO*GADR*REDM(2)*DFCSS2*DIV2/6.D0
      ENDIF
      ENDIF
C---------------------------------------------------------------
      IF(IBFLD.EQ.1) THEN
      write(*,*)'warning:in axial.02: ibfld=1: not yet implemented'
      return
      ENDIF
C---------------------------------------------------------------
C
C     GAUSSIAN CONTRIBUTION (ANN.PHYS. 208, EQN. (7.16)):
C
C---------------------------------------------------------------
c     UPSC0 =   VKULL*AMAX(IN)
c     UPSC1 =  -(1.5D0-XLAM1**2)*UPSC0
c     UPST0 =  + XLAM1**2*UPSC0/3.D0
c     DUPSC0=  -ALM1*XLAM1*UPSC0/PIM
c     FIC1 = -VKULL*AMAX(IN)
c     DFIC1= -ALM1*XLAM1*FIC1/PIM

c     VSIGLL  = VSIGLL  + 5*GALL*UPSC1*ALM1**2*DIV1/12.D0
c     VTENLL  = VTENLL  - GALL*UPST0*ALM1**2*DIV1/4.D0
c     FISLL   = FISLL   - GALL*REDM(1)*(UPSC0-FIC1/3.D0)*DIV1
c     DFISLL  = DFISLL  - GALL*REDM(1)*(DUPSC0-DFIC1/3.D0)*DIV1
C
c     UPSC0 =   VKULS*AMAX(IN)
c     UPSC1 =  -(1.5D0-XLAM3**2)*UPSC0
c     UPST0 =  + XLAM3**2*UPSC0/3.D0
c     DUPSC0=  -ALM3*XLAM3*UPSC0/PIM
c     FIC1 = -VKULS*AMAX(IN)
c     DFIC1= -ALM3*XLAM3*FIC1/PIM

c     VSIGLS  = VSIGLS  + 5*GALS*UPSC1*ALM3**2*DIV3/12.D0
c     VTENLS  = VTENLS  - GALS*UPST0*ALM3**2*DIV3/4.D0
c     FISLS   = FISLS   - GALS*REDM(3)*(UPSC0-FIC1/3.D0)*DIV3
c     DFISLS  = DFISLS  - GALS*REDM(3)*(DUPSC0-DFIC1/3.D0)*DIV3
C
c     UPSC0 =   VKUSS*AMAX(IN)
c     UPSC1 =  -(1.5D0-XLAM2**2)*UPSC0
c     UPST0 =  + XLAM2**2*UPSC0/3.D0
c     DUPSC0=  -ALM2*XLAM2*UPSC0/PIM
c     FIC1 = -VKUSS*AMAX(IN)
c     DFIC1= -ALM2*XLAM2*FIC1/PIM

c     VSIGSS  = VSIGSS  + 5*GASS*UPSC1*ALM2**2*DIV2/12.D0
c     VTENSS  = VTENSS  - GASS*UPST0*ALM2**2*DIV2/4.D0
c     FISSS   = FISSS   - GASS*REDM(2)*(UPSC0-FIC1/3.D0)*DIV2
c     DFISSS  = DFISSS  - GASS*REDM(2)*(DUPSC0-DFIC1/3.D0)*DIV2

c     VSIGDR  = VSIGDR  + 5*GADR*UPSC1*ALM2**2*DIV2/12.D0
c     VTENDR  = VTENDR  - GADR*UPST0*ALM2**2*DIV2/4.D0
c     FISDR   = FISDR   - GADR*REDM(2)*(UPSC0-FIC1/3.D0)*DIV2
c     DFISDR  = DFISDR  - GADR*REDM(2)*(DUPSC0-DFIC1/3.D0)*DIV2
C
  104 CONTINUE
 1040 CONTINUE
*     fiss = 0.d0
*     dfiss=0.d0
*     fiten=0.d0
*     dfiten=0.d0
C
      RETURN
      END
C**********************************************************************
C
**    SUBROUTINE AXIALU(NMAX,NLOC,ICSB,P)
      SUBROUTINE AXIALU(XA,NLOC,ICSB,P)
C
C**********************************************************************
C
C     AXIAL MESONS (UNNATURAL PARITY) POTENTIALS ON ISOSPIN BASIS
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGRTST,IGERST,IFRMF
      COMMON/ALLAX/FA(11),FB(11),ALMAX                           
      COMMON/MASSES/ PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
**    COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL   ,VCSS   ,VCLS   ,VCDR   ,
     .            VSIGLL ,VSIGSS ,VSIGLS ,VSIGDR ,
     .            VTENLL ,VTENSS ,VTENLS ,VTENDR ,
     .            VSOLL  ,VSOSS  ,VSOLS  ,VSODR  ,
     .            VSO2LL ,VSO2SS ,VSO2LS ,VSO2DR ,
     .            VASOLL ,VASOSS ,VASOLS ,VASODR ,
     .            VNNC   ,VNNSIG ,VNNTEN ,VNNSO  ,
     .            FILL   ,FISS   ,FILS   ,FIDR   ,
     .            DFILL  ,DFISS  ,DFILS  ,DFIDR  ,
     .            FISLL  ,FISSS  ,FISLS  ,FISDR  ,
     .            DFISLL ,DFISSS ,DFISLS ,DFISDR ,
     .            FITLL  ,FITSS  ,FITLS  ,FITDR  ,
     .            DFITLL ,DFITSS ,DFITLS ,DFITDR 
      DIMENSION AMAX(4)
      DATA SR3/1.732051D0/,SRPI/1.7724538509D0/,IPV/1/
      DATA AMB1,AMH1,AMH2,AMK1/1235.D0,1170.D0,1380.D0,1273.D0/
C
C   NOTE : B1(IN=1),H11 (IN=2),H11'(IN=3),K1B(IN=4)
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/
     .  1.7724538509D0)/(2.D00*XH*XH*XH)
C
      DIV1 =1.D0/(AM(1)*AMY(1))
      DIV2 =1.D0/(AM(1)*AMY(2))
      DIV3 =1.D0/(AM(1)*AMH   )
      DO 1040 IN=1,4
      GOTO(1051,1052,1053,1054),IN
1051  GALL= 0.D0   
      GASS= -2*FB(1)*FB(2)
      GALS= -SR3*FB(1)*FB(3)
      GADR= FB(1)*FB(2)
      AMAX(1)=AMB1
      GOTO 1055
1052  GALL=  FB(6)*FB(7)
      GASS=  FB(6)*FB(8)  
      GALS=  0.D0
      GADR=  FB(6)*FB(8)  
      AMAX(2)=AMH1
      GOTO 1055
1053  GALL=  FB(9)*FB(10)
      GASS=  FB(9)*FB(11)
      GALS=  0.D0
      GADR=  FB(9)*FB(11)
      AMAX(3)=AMH2
      GOTO 1055
1054  GALL=  FB(4)*FB(4)*P
      GASS= -FB(5)*FB(5)*P
      GALS= -SR3*FB(4)*FB(5)*P
      GADR= 2*FB(5)*FB(5)*P
      AMAX(4)=AMK1
C
1055  IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN      
      ALAM = ALMP8
      IF(IN.EQ.2) ALAM=ALMP1
      IF(IN.EQ.4) ALAM=ALMKA
      ENDIF
C
      ALM1 = ALAM
      ALM2 = ALAM
      ALM3 = ALAM
      RATM1=AMAX(IN)/ALM1
      RATM2=AMAX(IN)/ALM2
      RATM3=AMAX(IN)/ALM3
*     FAC1=AMAX(IN)**2/(4*AM(1)*AMY(1))
*     FAC2=AMAX(IN)**2/(4*AM(1)*AMY(2))
*     FAC3=AMAX(IN)**2/(4*AM(1)*AMH   )
C     SCALING COUPLING WITH PIM:
      FAC1=AMAX(IN)**2/(PIM*PIM)         
      FAC2=AMAX(IN)**2/(PIM*PIM)             
      FAC3=AMAX(IN)**2/(PIM*PIM)           
C
**    DO 104 I=2,NMAX
**    X = XA(I)
      X = XA   
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMAX(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMAX(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMAX(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMAX(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLL0  = FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLL0 = FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLL1  = FCLL0  - VKULL*AMAX(IN)
**    DFCLL0 = -X*FSOLL0
      DFCLL0 = -FSOLL0*XA*AMAX(IN)**2/PIM
      DFCLL1 =  DFCLL0 + ALM1*XLAM1*VKULL
      DFTLL0 =  DFCLL1/3.D0-3*FTLL0*PIM/XA
C
      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTSS0  = FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOSS0 = FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCSS1  = FCSS0  - VKUSS*AMAX(IN)
**    DFCSS0 = -X*FSOSS0
      DFCSS0 = -FSOSS0*XA*AMAX(IN)**2/PIM
      DFCSS1 =  DFCSS0 + ALM2*XLAM2*VKUSS
      DFTSS0 =  DFCSS1/3.D0-3*FTSS0*PIM/XA
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0  = FF0(EXPM,EX,X,DERFCM,DERFCP)*AMAX(IN)
      FTLS0  = FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FSOLS0 = FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMAX(IN)
      FCLS1  = FCLS0  - VKULS*AMAX(IN)
**    DFCLS0 = -X*FSOLS0
      DFCLS0 = -FSOLS0*XA*AMAX(IN)**2/PIM
      DFCLS1 =  DFCLS0 + ALM3*XLAM3*VKULS
      DFTLS0 =  DFCLS1/3.D0-3*FTLS0*PIM/XA
C
1041   VSIGLL   = VSIGLL  - GALL*FAC1*FCLL1/3.D0
       VSIGSS   = VSIGSS  - GASS*FAC2*FCSS1/3.D0
       VSIGLS   = VSIGLS  - GALS*FAC3*FCLS1/3.D0
       VSIGDR   = VSIGDR  - GADR*FAC2*FCSS1/3.D0

       VTENLL   = VTENLL  - GALL*FAC1*FTLL0
       VTENSS   = VTENSS  - GASS*FAC2*FTSS0
       VTENLS   = VTENLS  - GALS*FAC3*FTLS0
       VTENDR   = VTENDR  - GADR*FAC2*FTSS0

      IF(NLOC.EQ.0) GO TO 104
       FISLL    = FISLL  + GALL*FAC1*REDMM*FCLL1 *DIV1/6.D0
       FISSS    = FISSS  + GASS*FAC2*REDMM*FCSS1 *DIV2/6.D0
       FISLS    = FISLS  + GALS*FAC3*REDMM*FCLS1 *DIV3/6.D0
       FISDR    = FISDR  + GADR*FAC2*REDMM*FCSS1 *DIV2/6.D0

       DFISLL   = DFISLL + GALL*FAC1*REDMM*DFCLL1*DIV1/6.D0
       DFISSS   = DFISSS + GASS*FAC2*REDMM*DFCSS1*DIV2/6.D0
       DFISLS   = DFISLS + GALS*FAC3*REDMM*DFCLS1*DIV3/6.D0
       DFISDR   = DFISDR + GADR*FAC2*REDMM*DFCSS1*DIV2/6.D0

*      FITLL    = FITLL  + GALL*FAC1*REDMM*FTLL0 *DIV1/2.D0
*      DFITLL   = DFITLL + GALL*FAC1*REDMM*DFTLL0*DIV1/2.D0
C
  104 CONTINUE
C
 1040 CONTINUE
C
      RETURN
      END
C**********************************************************************
C
**    SUBROUTINE TENSOR(NMAX,NLOC,ICSB,P)
      SUBROUTINE TENSOR(XA,NLOC,ICSB,P)
C
C**********************************************************************
C
C     TENSOR MESONS : CALCULATION POTENTIALS ON ISOSPIN BASIS
C     VERSION: 8 NOVEMBER 1995
C
      IMPLICIT REAL *8(A-H,O-Z)
      COMMON/MODEL/IMODEL,INRS,ICNSTR,IRET,IDAM,IGRTST,IGERST,IFRMF
      COMMON/HVY/HFPS(11),GT(11),FT(11),FD(11),FV(11)
      COMMON/MASSES/ PIM,AM(3),AMY(3),REDM(3),PLAB,AK(3),AKS(3),TEM(3)
      COMMON/DYNMAS/REDMM,AMLN,AMSN,AMH,AMSS,AMLS,AMNN
      COMMON/FORMF/ALAMH,ALMP8,ALMV8,ALMS8,ALMP1,ALMV1,ALMS1,
     .             ALMKA,ALMKS,ALMKP
      COMMON/FRMFAC/ALMOBE,ALMNN,ALMLL,ALMSS,ALMLS,ALMLK,ALMSK
**    COMMON/AMAT/XA(300),A(9,6,300)
      COMMON/POTF/VCLL   ,VCSS   ,VCLS   ,VCDR   ,
     .            VSIGLL ,VSIGSS ,VSIGLS ,VSIGDR ,
     .            VTENLL ,VTENSS ,VTENLS ,VTENDR ,
     .            VSOLL  ,VSOSS  ,VSOLS  ,VSODR  ,
     .            VSO2LL ,VSO2SS ,VSO2LS ,VSO2DR ,
     .            VASOLL ,VASOSS ,VASOLS ,VASODR ,
     .            VNNC   ,VNNSIG ,VNNTEN ,VNNSO  ,
     .            FILL   ,FISS   ,FILS   ,FIDR   ,
     .            DFILL  ,DFISS  ,DFILS  ,DFIDR  ,
     .            FISLL  ,FISSS  ,FISLS  ,FISDR  ,
     .            DFISLL ,DFISSS ,DFISLS ,DFISDR ,
     .            FITLL  ,FITSS  ,FITLS  ,FITDR  ,
     .            DFITLL ,DFITSS ,DFITLS ,DFITDR 
      DIMENSION AMTS(4),FTS(4),XM1(3),XM2(3)
      DATA SR3/1.732051D0/,SRPI/1.772454D0/,AMPRO/938.2592D0/
      DATA AMTS/1310.4D0,1272.9D0,1520.4D0,1430.D0/
C
C   NOTE : A2(1320),F(1270),FP(1525),K*(1430): IN=1,2,3,4 RESP.
C
C   THE POTENTIAL FUNCTIONS
C
      FF0(ERATH,EXH,XH,EM,EP)=ERATH*(EM/EXH-EXH*EP)/(2.0D00*XH)
      FF1(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     . *(1.D00+XH)-EXH*EP*(1.D00-XH)-4.D00*XLAMH*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
      FF3(ERATH,EXH,XH,XLAMH,EM,EP,EXLAM)=ERATH*(EM/EXH
     .  *(1.D00+XH+XH*XH/3.D00)-EXH*EP*(1.D00-XH+XH*XH/3.D00)
     .  -8.D00*XLAMH*(0.5D00+XLAMH*XLAMH/3.D00)*EXLAM/ERATH/SRPI)
     .  /(2.D00*XH*XH*XH)
C
      DO 1040 IN=1,4
      GOTO(1051,1052,1053,1054),IN
1051  GDLL = 0.D0        
      GDFLL= 0.D0
      GFDLL= 0.D0
      GFLL = 0.D0
      GDSS = -2*GT(1)*GT(2)
      GDFSS= -2*GT(1)*FT(2)
      GFDSS= -2*FT(1)*GT(2)
      GFSS = -2*FT(1)*FT(2)
      GDLS = -GT(1)*GT(3)*SR3
      GDFLS= -GT(1)*FT(3)*SR3
      GFDLS= -FT(1)*GT(3)*SR3
      GFLS = -FT(1)*FT(3)*SR3
      GDDR = GT(1)*GT(2)
      GDFDR= GT(1)*FT(2)
      GFDDR= FT(1)*GT(2)
      GFDR = FT(1)*FT(2)
      XM1(1)=AM(1)
      XM1(2)=AM(1)
      XM1(3)=AM(1)
      XM2(1)=AMY(1)
      XM2(2)=AMY(1)
      XM2(3)=AMH   
      GOTO 1055
1052  GDLL = GT(6)*GT(7) 
      GDFLL= GT(6)*FT(7)
      GFDLL= FT(6)*GT(7)
      GFLL = FT(6)*FT(7)
      GDSS = GT(6)*GT(8)
      GDFSS= GT(6)*FT(8)
      GFDSS= FT(6)*GT(8)
      GFSS = FT(6)*FT(8)
      GDLS = 0.D0
      GDFLS= 0.D0
      GFDLS= 0.D0
      GFLS = 0.D0
      GDDR = GDSS       
      GDFDR= GDFSS      
      GFDDR= GFDSS      
      GFDR = GFSS        
      GOTO 1055
1053  GDLL = GT(9)*GT(10) 
      GDFLL= GT(9)*FT(10)
      GFDLL= FT(9)*GT(10)
      GFLL = FT(9)*FT(10)
      GDSS = GT(9)*GT(11)
      GDFSS= GT(9)*FT(11)
      GFDSS= FT(9)*GT(11)
      GFSS = FT(9)*FT(11)
      GDLS = 0.D0
      GDFLS= 0.D0
      GFDLS= 0.D0
      GFLS = 0.D0
      GDDR = GDSS       
      GDFDR= GDFSS      
      GFDDR= GFDSS      
      GFDR = GFSS        
      GOTO 1055
1054  GDLL = GT(4)*GT(4)*P
      GDFLL= GT(4)*FT(4)*P
      GFDLL= FT(4)*GT(4)*P
      GFLL = FT(4)*FT(4)*P
      GDSS = -GT(5)*GT(5)*P
      GDFSS= -GT(5)*FT(5)*P
      GFDSS= -FT(5)*GT(5)*P
      GFSS = -FT(5)*FT(5)*P
      GDLS = -GT(4)*GT(5)*P*SR3
      GDFLS= -GT(4)*FT(5)*P*SR3
      GFDLS= -FT(4)*GT(5)*P*SR3
      GFLS = -FT(4)*FT(5)*P*SR3
      GDDR = -2*GDSS       
      GDFDR= -2*GDFSS      
      GFDDR= -2*GFDSS      
      GFDR = -2*GFSS        
      XM1(1)=AMLN 
      XM1(2)=AMSN  
      XM1(3)=AMLS 
      XM2(1)=AMLN  
      XM2(2)=AMSN  
      XM2(3)=AMLS  
C
1055  FTS(IN) = 1.D0
      IF(IMODEL.LE.3) ALAM=ALMOBE
      IF(IMODEL.GE.4) THEN        
       ALAM = ALMV8
       IF(IN.EQ.2) ALAM = ALMV1
       IF(IN.EQ.4) ALAM = ALMKS
      ENDIF
      ALM1 = ALAM
      ALM2 = ALAM
      ALM3 = ALAM

      RATM1=AMTS(IN)/ALM1
      RATM2=AMTS(IN)/ALM2
      RATM3=AMTS(IN)/ALM3
      FAC0=AMTS(IN)*AMTS(IN)/AMPRO/AMPRO
      FAC1=AMTS(IN)*AMTS(IN)/(XM1(1)*XM2(1))
      FAC2=AMTS(IN)*AMTS(IN)/(XM1(2)*XM2(2))
      FAC3=AMTS(IN)*AMTS(IN)/(XM1(3)*XM2(3))
C
*     CCNN1=-FAC1*(5*GDNN/6.D0+(GFDNN+GDFNN)*DSQRT(XM1*XM2)
*    .       /6.D0/AMPRO)
      CCLL1=-FAC1*5*GDLL/6.D0-(GFDLL/XM1(1)+GDFLL/XM2(1))
     .       *AMTS(IN)**2/(6.D0*AMPRO)
      CCSS1=-FAC2*5*GDSS/6.D0-(GFDSS/XM1(2)+GDFSS/XM2(2))
     .       *AMTS(IN)**2/(6.D0*AMPRO)
      CCLS1=-FAC3*5*GDLS/6.D0-(GFDLS/XM1(3)+GDFLS/XM2(3))
     .       *AMTS(IN)**2/(6.D0*AMPRO)
      CCDR1=-FAC2*5*GDDR/6.D0-(GFDDR/XM1(2)+GDFDR/XM2(2))
     .       *AMTS(IN)**2/(6.D0*AMPRO)

*     CSNN1=-FAC1*(GDNN*AMPRO+GFDNN*XM1+GDFNN*XM2+GFNN*XM1*XM2/AMPRO)
*    .       /AMPRO/12.D0
      CSLL1=-FAC1*(GDLL+(GFDLL*XM1(1)+GDFLL*XM2(1))/AMPRO
     .            +GFLL*XM1(1)*XM2(1)/AMPRO**2)/12.D0
      CSSS1=-FAC2*(GDSS+(GFDSS*XM1(2)+GDFSS*XM2(2))/AMPRO
     .            +GFSS*XM1(2)*XM2(2)/AMPRO**2)/12.D0
      CSLS1=-FAC3*(GDLS+(GFDLS*XM1(3)+GDFLS*XM2(3))/AMPRO
     .            +GFLS*XM1(3)*XM2(3)/AMPRO**2)/12.D0
      CSDR1=-FAC2*(GDDR+(GFDDR*XM1(2)+GDFDR*XM2(2))/AMPRO
     .            +GFDR*XM1(2)*XM2(2)/AMPRO**2)/12.D0

*     CTNN0=-1.50D0*CSNN1
      CTLL0=-1.50D0*CSLL1
      CTSS0=-1.50D0*CSSS1
      CTLS0=-1.50D0*CSLS1
      CTDR0=-1.50D0*CSDR1

*     CONN0= FAC1*(5*GDNN/3.D0+(GDFNN+GFDNN)*DSQRT(XM1*XM2)/AMPRO )
      COLL0= FAC1*(5*GDLL/3.D0+(GDFLL*XM2(1)+GFDLL*XM1(1))/AMPRO )
      COSS0= FAC2*(5*GDSS/3.D0+(GDFSS*XM2(2)+GFDSS*XM1(2))/AMPRO )
      COLS0= FAC3*(5*GDLS/3.D0+(GDFLS*XM2(3)+GFDLS*XM1(3))/AMPRO )
      CODR0= FAC2*(5*GDDR/3.D0+(GDFDR*XM2(2)+GFDDR*XM1(2))/AMPRO )

*     CO2NN=-FAC1**2*(7*GDNN/6.D0+2*(GDFNN+GFDNN)*DSQRT(XM1*XM2)/AMPRO
*    +      +3*GFNN*XM1*XM2/AMPRO/AMPRO)/4.D0
      CO2LL=-FAC1**2*(7*GDLL/6.D0+2*(GDFLL*XM2(1)+GFDLL*XM1(1))/AMPRO
     +      +3*GFLL*XM1(1)*XM2(1)/AMPRO/AMPRO)/4.D0
      CO2SS=-FAC2**2*(7*GDSS/6.D0+2*(GDFSS*XM2(2)+GFDSS*XM1(2))/AMPRO
     +      +3*GFSS*XM1(2)*XM2(2)/AMPRO/AMPRO)/4.D0
      CO2LS=-FAC3**2*(7*GDLS/6.D0+2*(GDFLS*XM2(3)+GFDLS*XM1(3))/AMPRO
     +      +3*GFLS*XM1(3)*XM2(3)/AMPRO/AMPRO)/4.D0
      CO2DR=-FAC2**2*(7*GDDR/6.D0+2*(GDFDR*XM2(2)+GFDDR*XM1(2))/AMPRO
     +      +3*GFDR*XM1(2)*XM2(2)/AMPRO/AMPRO)/4.D0

*     FINN0=-(11*GDNN/3.D0)
      FILL0=-(11*GDLL/3.D0)
      FISS0=-(11*GDSS/3.D0)
      FILS0=-(11*GDLS/3.D0)
      FIDR0=-(11*GDDR/3.D0)
C
**    DO 104 I=2,NMAX
**    X = XA(I)
      X = XA   
      XLAM1=0.5D0*X*ALM1/PIM
      XLAM2=0.5D0*X*ALM2/PIM
      XLAM3=0.5D0*X*ALM3/PIM
      X =(AMTS(IN)/PIM)*X
      EX=FDEXP(X)
      VKULL=(ALM1/AMTS(IN))**3*FDEXP(-XLAM1*XLAM1)/(2.D0*SRPI)
      VKUSS=(ALM2/AMTS(IN))**3*FDEXP(-XLAM2*XLAM2)/(2.D0*SRPI)
      VKULS=(ALM3/AMTS(IN))**3*FDEXP(-XLAM3*XLAM3)/(2.D0*SRPI)
C
      EXPM=DEXP(RATM1*RATM1)
      ELAM=FDEXP(-XLAM1*XLAM1)
      DERFCM=FDERFC(-XLAM1+RATM1)
      DERFCP=FDERFC( XLAM1+RATM1)
      FCLL0= FF0(EXPM,EX,X,DERFCM,DERFCP)*AMTS(IN)
      FTENLL=FF3(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMTS(IN)
      FSOLL =FF1(EXPM,EX,X,XLAM1,DERFCM,DERFCP,ELAM)*AMTS(IN)
      FSO2LL= 3*FTENLL/(X*X)
C
      EXPM=DEXP(RATM2*RATM2)
      ELAM=FDEXP(-XLAM2*XLAM2)
      DERFCM=FDERFC(-XLAM2+RATM2)
      DERFCP=FDERFC( XLAM2+RATM2)
      FCSS0= FF0(EXPM,EX,X,DERFCM,DERFCP)*AMTS(IN)
      FTENSS=FF3(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMTS(IN)
      FSOSS =FF1(EXPM,EX,X,XLAM2,DERFCM,DERFCP,ELAM)*AMTS(IN)
      FSO2SS= 3*FTENSS/(X*X)
C
      EXPM=DEXP(RATM3*RATM3)
      ELAM=FDEXP(-XLAM3*XLAM3)
      DERFCM=FDERFC(-XLAM3+RATM3)
      DERFCP=FDERFC( XLAM3+RATM3)
      FCLS0= FF0(EXPM,EX,X,DERFCM,DERFCP)*AMTS(IN)
      FTENLS=FF3(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMTS(IN)
      FSOLS =FF1(EXPM,EX,X,XLAM3,DERFCM,DERFCP,ELAM)*AMTS(IN)
      FSO2LS= 3*FTENLS/(X*X)
C
      FCLL1= FCLL0  - VKULL*AMTS(IN)
      FCLL2= FCLL1  + (1.5D0-XLAM1*XLAM1)*VKULL*AMTS(IN)/RATM1**2
      FTLL1= FTENLL - XLAM1*XLAM1*VKULL*AMTS(IN)/(3*RATM1*RATM1)
      FOLL1= FSOLL  - VKULL*AMTS(IN)/(2*RATM1*RATM1)
C
      FCSS1= FCSS0  - VKUSS*AMTS(IN)
      FCSS2= FCSS1  + (1.5D0-XLAM2*XLAM2)*VKUSS*AMTS(IN)/RATM2**2
      FTSS1= FTENSS - XLAM2*XLAM2*VKUSS*AMTS(IN)/(3*RATM2*RATM2)
      FOSS1= FSOSS  - VKUSS*AMTS(IN)/(2*RATM2*RATM2)
C
      FCLS1= FCLS0  - VKULS*AMTS(IN)
      FCLS2= FCLS1  + (1.5D0-XLAM3*XLAM3)*VKULS*AMTS(IN)/RATM3**2
      FTLS1= FTENLS - XLAM3*XLAM3*VKULS*AMTS(IN)/(3*RATM3*RATM3)
      FOLS1= FSOLS  - VKULS*AMTS(IN)/(2*RATM3*RATM3)
C
      VCLL    = VCLL  -  2*GDLL*FCLL0/3.D0 + CCLL1*FCLL1
     .                     -GFLL*FAC0*FAC1*FCLL2/96.D0
      VCSS    = VCSS  -  2*GDSS*FCSS0/3.D0 + CCSS1*FCSS1
     .                     -GFSS*FAC0*FAC2*FCSS2/96.D0
      VCLS    = VCLS  -  2*GDLS*FCLS0/3.D0 + CCLS1*FCLS1
     .                     -GFLS*FAC0*FAC3*FCLS2/96.D0
      VCDR    = VCDR  -  2*GDDR*FCSS0/3.D0 + CCDR1*FCSS1
     .                     -GFDR*FAC0*FAC2*FCSS2/96.D0

      VSIGLL  = VSIGLL   +  CSLL1*FCLL1
     .                    -INRS*GFLL*FAC0*FCLL2*FAC1/96.D0
      VSIGSS  = VSIGSS   +  CSSS1*FCSS1
     .                    -INRS*GFSS*FAC0*FCSS2*FAC2/96.D0
      VSIGLS  = VSIGLS   +  CSLS1*FCLS1
     .                    -INRS*GFLS*FAC0*FCLS2*FAC3/96.D0
      VSIGDR  = VSIGDR   +  CSDR1*FCSS1
     .                    -INRS*GFDR*FAC0*FCSS2*FAC2/96.D0

      VTENLL  = VTENLL   +  CTLL0*FTENLL
     .                    +INRS*GFLL*FAC0*FTLL1*FAC1/64.D0
      VTENSS  = VTENSS   +  CTSS0*FTENSS
     .                    +INRS*GFSS*FAC0*FTSS1*FAC2/64.D0
      VTENLS  = VTENLS   +  CTLS0*FTENLS
     .                    +INRS*GFLS*FAC0*FTLS1*FAC3/64.D0
      VTENDR  = VTENDR   +  CTDR0*FTENSS
     .                    +INRS*GFDR*FAC0*FTSS1*FAC2/64.D0

      VSOLL   = VSOLL    +  COLL0*FSOLL
     .                    +3*GFLL*FAC0*FOLL1*FAC1/16.D0
      VSOSS   = VSOSS    +  COSS0*FSOSS
     .                    +3*GFSS*FAC0*FOSS1*FAC2/16.D0
      VSOLS   = VSOLS    +  COLS0*FSOLS
     .                    +3*GFLS*FAC0*FOLS1*FAC3/16.D0
      VSODR   = VSODR    +  CODR0*FSOSS
     .                    +3*GFDR*FAC0*FOSS1*FAC2/16.D0

      VSO2LL  = VSO2LL   +  CO2LL*FSO2LL
      VSO2SS  = VSO2SS   +  CO2SS*FSO2SS
      VSO2LS  = VSO2LS   +  CO2LS*FSO2LS
      VSO2DR  = VSO2DR   +  CO2DR*FSO2SS
C
C     K*(1430): K_{MU}K_{NU}-TERMS IN TENSOR MESON PROPAGATOR:
C
*     SUPPOSED CAN BE NEGLECTED
C
      IF(NLOC.EQ.0) GOTO 104
      FILL   = FILL     +  REDMM*FILL0*FCLL0/(XM1(1)*XM2(1))
      FISS   = FISS     +  REDMM*FISS0*FCSS0/(XM1(2)*XM2(2))
      FILS   = FILS     +  REDMM*FILS0*FCLS0/(XM1(3)*XM2(3))
      FIDR   = FIDR     +  REDMM*FIDR0*FCSS0/(XM1(2)*XM2(2))
C
      DFILL  = DFILL    -  REDMM*FILL0*FSOLL*X*FAC1/AMTS(IN)
      DFISS  = DFISS    -  REDMM*FISS0*FSOSS*X*FAC2/AMTS(IN)
      DFILS  = DFILS    -  REDMM*FILS0*FSOLS*X*FAC3/AMTS(IN)
      DFIDR  = DFIDR    -  REDMM*FIDR0*FSOSS*X*FAC2/AMTS(IN)
  104 CONTINUE
C
 1040 CONTINUE
C
      RETURN
      END


