C *******************************************************************
c     (SIMPLIFIED) VERSION FOR USER
C *******************************************************************
c     DECEMBER 2004: VERSION YNPOT.DEC04 = yampot.dec04
c                    AND CORRESPONDS TO YNPROGS.04
C *******************************************************************
c     version: nchan=1 -> Sigma(+)-proton
c              nchan=2 -> Lambda  -neutron
c              nchan=3 -> Lambda  -proton  
c     note: sigma(-)-proton, not proper threshold treatment!!!
c--------------------------------------------------------------------
C     Model-options:
C     *********************************************************************
C     *  ESC04: OSAKA-VERSION DECEMBER 2004                               *
C     *                                                                   *
C     *  IMODEL = 1 : Hard-Core MODEL PRD15 = YN-model D                  *
C     *  IMODEL = 2 : Hard-Core MODEL PRD20 = YN-model F                  *
C     *                                                                   *
C     *  IMODEL = 3 : Soft-Core MODEL NSC97f= YN-model                    *
C     *  IMODEL = 4 : Soft-Core MODEL NSC97e= YN-model                    *
C     *                                                                   *
C     *  IMODEL = 6 : Soft-Core MODEL ESC04A= NN+YN-model, paper II, 2005 *
C     *  IMODEL = 7 : Soft-Core MODEL ESC04B= NN+YN-model, paper II, 2005 *
C     *  IMODEL = 8 : Soft-Core MODEL ESC04C= NN+YN-model, paper II, 2005 *
C     *  IMODEL = 9 : Soft-Core MODEL ESC04D= NN+YN-model, paper II, 2005 *
C                                                                         *
C     *********************************************************************

C *******************************************************************

      IMPLICIT REAL*8(A-H,O-Z)
c--------------------------------------------------------------------
C     THE POTENTIALS ON THE ISOSPIN-BASIS ARE COMMUNICATED TO THE
C     CALLING PROGRAM VIA
c--------------------------------------------------------------------
      COMMON/POT/VCLL,VSIGLL,VTENLL,VSOLL,VSO2LL,FILL,DFILL,DDFILL,
     .           VCSS,VSIGSS,VTENSS,VSOSS,VSO2SS,FISS,DFISS,DDFISS,
     .           VCLS,VSIGLS,VTENLS,VSOLS,VSO2LS,FILS,DFILS,DDFILS,
     .           VCDR,VSIGDR,VTENDR,VSODR,VSO2DR,FIDR,DFIDR,DDFIDR,
     .           FISLL,DFISLL,DDFSLL,FISSS,DFISSS,DDFSSS,
     .           FISLS,DFISLS,DDFSLS,FISDR,DFISDR,DDFSDR,
     .           VASOLL,VASOSS,VASOLS,VASODR
c--------------------------------------------------------------------
      DIMENSION VI(8,4),BM(3,3),BMP(3,3)                      
      DIMENSION KSTPD(4)                            
      DATA NSTPD/2/,KSTPD/20,40,100,0/,X0/0.D0/,H/0.03D0/,XMIN/0.D0/
      INTEGER P
c--------------------------------------------------------------------
C
C     NCHAN=2  LABELS CHANNELS :
C     LAMBDA-NEUTRON=1, SIGMA(0)-NEUTRON=2, SIGMA(-)-PROTON=3
C     NCHAN=3  LABELS CHANNELS :
C     LAMBDA-PROTON =1, SIGMA(+)-NEUTRON=2, SIGMA(0)-PROTON=3
C
C II) FOR NCHAN=1 (SIGMA(+)-PROTON CHANNEL) VIA
C     COMMON/POT/, NAMELY THROUGH THE POTENTIALS
C     VCDR,VSIGDR,VTENDR,VSODR,VSO2DR,FIDR,DFIDR,DDFIDR .
C
C     UNITS :  X IN PIM**-1, USED PIM=138.041 MEV
C              VC,VSIG,VTEN,VSO,VSO2 IN MEV**+1
C              FI IN MEV**-1 , DFI IN MEV**0 , DDFI IN MEV**+1
C
C *******************************************************************
      data pim/138.041d0/,amf/197.32d0/
C -------------------------------------------------------------------
c     setting model and channel parameters:
*     data imodel/ 1/,nbase/2/,nchan/3/       ! HC-model D
*     data imodel/ 2/,nbase/2/,nchan/3/       ! HC-model F
*     data imodel/ 3/,nbase/2/,nchan/3/       ! PRC40-model (NSC89)
*     data imodel/ 4/,nbase/2/,nchan/3/       ! NSC97f-model 
*     data imodel/ 5/,nbase/2/,nchan/3/       ! NSC97e-model 
*     data imodel/ 6/,nbase/2/,nchan/3/       ! ESC04A
*     data imodel/ 7/,nbase/2/,nchan/3/       ! ESC04B
*     data imodel/ 8/,nbase/2/,nchan/3/       ! ESC04C
*     data imodel/ 9/,nbase/2/,nchan/3/       ! ESC04D
***   data imodel/ 6/,nbase/2/,nchan/1/       ! for S+p            
C -------------------------------------------------------------------
C     EXAMPLE PUTTING RUN PARAMETERS (TO BE ADAPTED BY USER):
c     1. model and channel parameters:
      data imodel/ 9/,nbase/2/,nchan/3/       ! ESC04D
c     2. angular momentum definition:
      data lint/0/,jspin/0/                          ! for example
c     3. choice esc-parameter set, special parameters:
      data igreen/0/,ns/1/
c     4. range pionts in r-space:
      data npnt/50/,xfm0/0.01d0/,dxfm/0.015d0/        ! for example
C -------------------------------------------------------------------

      open( 6,file='outpot.data')

c -------------------------------------------------------------------
c     input parameters potcall:
      write(6,*) 'potcall: imodel,nbase,nchan=',imodel,nbase,nchan
      write(6,*) 'potcall: lint, jspin,igreen,ns=',          
     .                     lint, jspin,igreen,ns             
c -------------------------------------------------------------------
c     for normal use ynpot.dec04:
*     do 1 i=1,npnt
*     xfm=xfm0+(i-1)*dxfm
*     x  = xfm*pim/amf
c -------------------------------------------------------------------
c     for test ynpot.dec04, comparison with ynlp04.f etc:
c
      do 1 i=1,50            
      if(i.eq.1) then
      x=x0+h
      else
      hh=h
      do 71 ii=1,nstpd
   71 if(i.gt.kstpd(ii)) hh=2*hh
      x = xmin + hh
      endif
      xmin=x
      xfm= x*amf/pim
      if(mod(i,2).eq.0) goto 1
c -------------------------------------------------------------------

c -------------------------------------------------------------------
      CALL HNPOT04(IMODEL,X,LINT,JSPIN,NCHAN,NBASE,IGREEN,NS) 
c -------------------------------------------------------------------
c     Potentials on the particle basis:
c     if(nbase.eq.2) then
c     do 301 k=1,8
c     bm(1,1)=vi(k,1)
c     bm(2,2)=vi(k,2)
c     bm(1,2)=vi(k,3)
c     bm(3,3)=vi(k,4)
c     bm(2,1)=bm(k,2)
c     if(nchan.eq.2) call tranln(bmp,bm)
c     if(nchan.eq.3) call tranlp(bmp,bm)
c     do 302 ii=1,3
c     do 302 jj=1,3
c 302 vprt(k,ii,jj)=bmp(ii,jj)
c 301 continue
c     endif
c -------------------------------------------------------------------

      print 10, xfm,vcll,vsigll,vtenll,vsoll,vso2ll,fill,dfill,ddfill,
     .          fisll,dfisll,ddfsll,
     .          xfm,vcls,vsigls,vtenls,vsols,vso2ls,fils,dfils,ddfils,
     .          fisls,dfisls,ddfsls,
     .          xfm,vcss,vsigss,vtenss,vsoss,vso2ss,fiss,dfiss,ddfiss,
     .          fisss,dfisss,ddfsss,
     .          xfm,vcdr,vsigdr,vtendr,vsodr,vso2dr,fidr,dfidr,ddfidr,
     .          fisdr,dfisdr,ddfsdr
   10 format(' xfm=',f7.3,
     .            ' vcll =',d10.3,' vsigll=',d10.3,' vtenll=',d10.3,/,
     .        12x,' vsoll=',d10.3,' vso2ll=',d10.3,/,
     .        12x,' fill =',d10.3,'  dfill=',d10.3,' ddfill=',d10.3,/,
     .        12x,' fisll=',d10.3,' dfisll=',d10.3,' ddfsll=',d10.3,/,
     .       ' xfm=',f7.3,
     .            ' vcls =',d10.3,' vsigls=',d10.3,' vtenls=',d10.3,/,
     .        12x,' vsols=',d10.3,' vso2ls=',d10.3,/,
     .        12x,' fils =',d10.3,' dfils =',d10.3,' ddfils=',d10.3,/,
     .        12x,' fisls=',d10.3,' dfisls=',d10.3,' ddfsls=',d10.3,/,
     .       ' xfm=',f7.3,
     .            ' vcss =',d10.3,' vsigss=',d10.3,' vtenss=',d10.3,/,
     .        12x,' vsoss=',d10.3,' vso2ss=',d10.3,/,
     .        12x,' fiss =',d10.3,' dfiss =',d10.3,' ddfiss=',d10.3,/,
     .        12x,' fisss=',d10.3,' dfisss=',d10.3,' ddfsss=',d10.3,/,
     .       ' xfm=',f7.3,
     .            ' vcdr =',d10.3,' vsigdr=',d10.3,' vtendr=',d10.3,/,
     .        12x,' vsodr=',d10.3,' vso2dr=',d10.3,/,
     .        12x,' fidr =',d10.3,' dfidr =',d10.3,' ddfidr=',d10.3,/,   
     .        12x,' fisdr=',d10.3,' dfisdr=',d10.3,' ddfsdr=',d10.3,//)
c -------------------------------------------------------------------
    1 continue

      stop
      end













